/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// EncoderSetupDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENCODERSETUPDLG_H__649CE06C_279A_458F_A2D4_D8F733225FC8__INCLUDED_)
#define AFX_ENCODERSETUPDLG_H__649CE06C_279A_458F_A2D4_D8F733225FC8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Definition
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define		CHANNEL1	0
#define		CHANNEL2	1
#define		CHANNEL3	2
#define		CHANNEL4	3
#define		CHANNEL5	4

#define		MAX_720P_FRAMES			45	// 720P ػ󵵷 45fps ִ  
#define		MAX_USEFUL_1080i_FRAMES	15	// 1080i   ִ ִ fps

#define		RES_1080i	0
#define		RES_720p	1
#define		RES_D1		2
#define		RES_CIF		3
#define		RES_QCIF	4

#define		CODEC_NONE	0
#define		CODEC_H264	1
#define		CODEC_MPEG4	2
#define		CODEC_MJPEG	3

#define		BITRATE_VBR	0
#define		BITRATE_CBR	1

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "LiveDemo.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CEncoderSetupDlg dialog

class CEncoderSetupDlg : public CDialog
{
public:
	CLiveObject			*m_LiveCamera;
	ENCODE_SETUP_INFO	m_EncoderSetupInfo[ENCODE_SETUP_CHANNEL_COUNT];
	
	double				m_lFrameRateTable[5];	// ػ󵵺 MAX Frame rate
	BOOL				m_FirstLoad;

	//..................................................
	// Construction
public:
	CEncoderSetupDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CEncoderSetupDlg();

	//..................................................

public:
	
	void Init( void *pLiveCamera );

	//..................................................

	void CalcFrameRate( int nCurChannel );

	//..................................................

	void SetEncoderResolution();
	void SetChannelEncoderData();

	//..................................................

	int	 SetEncoderDataToServer();
	void GetEncoderDataFromServer();

	//..................................................
	// Dialog Data
	//{{AFX_DATA(CEncoderSetupDlg)
	enum { IDD = IDD_DIALOG_ENCODER_SETUP };
	CEdit	m_edtVideoName;
	CEdit	m_edtCodecName;
	CComboBox	m_cboResolution;
	CComboBox	m_cboCodecType;
	CComboBox	m_cboQuality;
	CComboBox	m_cboGOPInterval;
	CComboBox	m_cboFrameRate;
	CComboBox	m_cboBitRateMode;
	CComboBox	m_cboBitRate;
	CTabCtrl	m_EncoderSetupTab;
	CString	m_strVideoName;
	CString	m_strCodecName;
	//}}AFX_DATA

	//..................................................
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEncoderSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	//..................................................
	// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEncoderSetupDlg)
	afx_msg void OnSelchangeTabEncoderSetup(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonApply();
	afx_msg void OnSelchangeComboResolution();
	afx_msg void OnSelchangeComboBitRateMode();
	afx_msg void OnSelchangeComboCodecType();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENCODERSETUPDLG_H__649CE06C_279A_458F_A2D4_D8F733225FC8__INCLUDED_)
