/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// LiveDemo.cpp: implementation of the CLiveObject class.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ProbeDemo.h"
#include "LiveDemo.h"
#include <process.h>

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Callback Function
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int g_nCount=0;
void CALLBACK AudioSendProc( HWAVEIN hwi, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2 )
{
	if (uMsg == WIM_DATA)
	{
		WAVEHDR* lpwvhdr = (WAVEHDR*) dwParam1;
		CLiveChannel *pLiveChannel = (CLiveChannel*)dwInstance;

		if( lpwvhdr->lpData != NULL && lpwvhdr->dwBufferLength > 0 )
		{
			pLiveChannel->EncodeAudio( lpwvhdr );
			if( pLiveChannel->GetRecordingStatus() )
				waveInAddBuffer( hwi, lpwvhdr, sizeof(WAVEHDR));
		}
	}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Static Function
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_RECV_CTRL_DATA(HANDLE hCallback, char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_RECV_CTRL_DATA(szCommandCode, param1, param2);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_RECV_VIDEO_CTRL_DATA(HANDLE hCallback, char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_RECV_VIDEO_CTRL_DATA(szCommandCode, param1, param2);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_RECV_VIDEO_DATA(HANDLE hCallback, VIDEO_DATA_PACK *lpData, DWORD_PTR param1, DWORD_PTR param2)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_RECV_VIDEO_DATA(lpData, param1, param2);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_RECV_AUDIO_SPEAKER_CTRL_DATA(HANDLE hCallback, char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_RECV_AUDIO_SPEAKER_CTRL_DATA(szCommandCode, param1, param2);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_RECV_AUDIO_SPEAKER_DATA(HANDLE hCallback, AUDIO_DATA_PACK *lpData)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_RECV_AUDIO_SPEAKER_DATA(lpData);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_RECV_AUDIO_MIC_CTRL_DATA(HANDLE hCallback, char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_RECV_AUDIO_MIC_CTRL_DATA(szCommandCode, param1, param2);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_ERROR_CTRL(HANDLE hCallback, int nErrorCode)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_ERROR_CTRL(nErrorCode);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_ERROR_VIDEO(HANDLE hCallback, int nErrorCode)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_ERROR_VIDEO(nErrorCode);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_ERROR_AUDIO_SPEAKER(HANDLE hCallback, int nErrorCode)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_ERROR_AUDIO_SPEAKER(nErrorCode);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::_ON_ERROR_AUDIO_MIC(HANDLE hCallback, int nErrorCode)
{
	CLiveChannel *pDlg = (CLiveChannel *)hCallback;
	if(pDlg)
	{
		pDlg->ON_ERROR_AUDIO_MIC(nErrorCode);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_RECV_CTRL_DATA(char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
	TRACE( "%s\n",szCommandCode );
	if(lstrcmp(szCommandCode, "SCF") == 0)		// PTZ Response
	{
		//TRACE( "%s\n",szCommandCode );

		BYTE  *lpParam = (BYTE  *)param1;
		DWORD  opcode = (DWORD)lpParam[0];
		BYTE  *lpParam2 = (BYTE  *)&lpParam[1];

		if(opcode == PTZ_SPAN)			//	Pan Position Status
		{
			WORD wpanpos = (WORD)(lpParam2[1] << 8)|(WORD)(lpParam2[0]);

		}
		else if(opcode == PTZ_STILT)	//	Tilt Position Status
		{
			WORD wtiltpos = (WORD)(lpParam2[1] << 8)|(WORD)(lpParam2[0]);

		}
		else if(opcode == PTZ_SDIN)		//	In Status
		{
			WORD wDIStatus = (WORD)(lpParam2[1] << 8)|(WORD)(lpParam2[0]);
			for( int idx=0; idx<MAX_ALARMIN_COUNT; idx++ )
			{
				if( wDIStatus & 0x01<<idx )
				{
					if( idx == 0 )		
					{
						m_bEventAlarmInput1 = TRUE;
						//TRACE( "%ld, [ Sendsor In Event(%d) - On ]\n", GetTickCount(), idx );
					}
					else if( idx == 1 )	
					{
						m_bEventAlarmInput2 = TRUE;
						//TRACE( "%ld, [ Sendsor In Event(%d) - On ]\n", GetTickCount(), idx );
					}
					
					//TRACE( "[ Sendsor In Event(%d) ]", idx );
				}
				else
				{
					if( idx == 0 )		
					{
						m_bEventAlarmInput1 = FALSE;
						//TRACE( "%ld, [ Sendsor In Event(%d) - Off ]\n", GetTickCount(), idx );
					}
					else if( idx == 1 )	
					{
						m_bEventAlarmInput2 = FALSE;
						//TRACE( "%ld, [ Sendsor In Event(%d) - Off ]\n", GetTickCount(), idx );
					}
				}
				
			}

		}
		else if(opcode == PTZ_SDOUT)	//	Out Status
		{
			WORD wDOStatus = (WORD)(lpParam2[1] << 8)|(WORD)(lpParam2[0]);
			for( int idx=0; idx<MAX_ALARMOUT_COUNT; idx++ )
			{
				if(wDOStatus & 0x01<<idx)
				{
					if( idx == 0 )		
					{
						
						TRACE( "%ld, [ Sendsor Out Event(%d) - On ]\n", GetTickCount(), idx );
					}
					else if( idx == 1 )	
					{
						
						//TRACE( "%ld, [ Sendsor Out Event(%d) - On ]\n", GetTickCount(), idx );
					}
					
					//TRACE( "[ Sendsor Out Event(%d) ]", idx );
				}
				else
				{
					if( idx == 0 )		
					{
						TRACE( "%ld, [ Sendsor Out Event(%d) - Off ]\n", GetTickCount(), idx );
					}
					else if( idx == 1 )	
					{
						//TRACE( "%ld, [ Sendsor Out Event(%d) - Off ]\n", GetTickCount(), idx );
					}
				}
			}

		}
		else if(opcode == PTZ_GETZOOMPOS) //	Get Zoom Position
		{
			WORD wzoompos = (WORD)(lpParam2[1] << 8)|(WORD)(lpParam2[0]);

		}
		else if(opcode == PTZ_GETPTZPOS) //	Get Pan/Tilt/Zoom Position 
		{
			WORD wPanpos = (WORD)(lpParam2[1] << 8)|(WORD)(lpParam2[0]);
			WORD wTiltpos = (WORD)(lpParam2[3] << 8)|(WORD)(lpParam2[2]);
			WORD wZoompos = (WORD)(lpParam2[5] << 8)|(WORD)(lpParam2[4]);

			memcpy( m_pwPan, &wPanpos, sizeof(WORD));
			memcpy( m_pwTilt, &wTiltpos, sizeof(WORD));
			memcpy( m_pwZoom, &wZoompos, sizeof(WORD));
		}
	}
	else if( lstrcmp(szCommandCode, "CNS") == 0 )
	{
		// Real connection
		m_nControlStatus = STATUS_CONNECTED;
	}
	else if( lstrcmp(szCommandCode, "LGS") == 0 )
	{
		m_nControlStatus = STATUS_LOGON;
	}
	else if( lstrcmp(szCommandCode, "LGW") == 0 )
	{
		m_nControlStatus = STATUS_LOGON_FAIL;
	}
	else if( lstrcmp(szCommandCode, "CLS") == 0  )
	{
		m_nControlStatus = STATUS_LOGOFF;
	}
	else if( lstrcmp(szCommandCode, "STA") == 0  )
	{
		m_nControlStatus = STATUS_LOGON;
	}
	else if( lstrcmp(szCommandCode, "RSD") == 0 )
	{
		BYTE  *lpTemp = (BYTE  *)param1;
		DWORD opcode = (DWORD)lpTemp[0];
		BYTE  *lpParam = (BYTE  *)&lpTemp[1];

		memcpy(&m_CameraConfig, lpTemp, sizeof(m_CameraConfig));
	}
	else if(lstrcmp(szCommandCode, "NVS") == 0) // motion status
	{
		BYTE  *lpParam = (BYTE  *)param1;
		BYTE btMotionDeteced  = (BYTE)(lpParam[0] & 0x01);
		BYTE btMotionTracking = (BYTE)(lpParam[0] & 0x02);
		BYTE btVideoFormat    = (BYTE)(lpParam[0] & 0x04);
		BYTE btFocusMode	  = (BYTE)(lpParam[0] & 0x80);
		BYTE btIRISMode		  = (BYTE)(lpParam[0] & 0x40);
		
		m_bEventMotion	= btMotionDeteced ? TRUE : FALSE;
//		TRACE( "Motion : %s\n", btMotionDeteced ? "Detected" : "None" );

//		m_bFocusMode	= btFocusMode?TRUE:FALSE;				// Focus : 0(AUTO), 1(MANUAL, SEMIAUTO)		  * (1)϶   Ȱȭ Ŵ
//		m_bIRISMode		= btIRISMode?TRUE:FALSE;				// IRIS : AUTO EXPOSURE SETUP -> AE MODE  
																// 0(AUTO,SHUTTER,BRIGHT), 1(IRIS, MANUAL)    * (1)϶   Ȱȭ Ŵ

//		TRACE( "FocusMode(%d), Iris(%d)\n", m_bFocusMode, m_bIRISMode );
	}
	else if(lstrcmp(szCommandCode, "RSU") == 0) // Response User authentication
	{
		BYTE  *lpParam = (BYTE  *)param1;
		if(lpParam[0] == 0)	// none
		{
			m_nAuthentication = NONE;
		}
		else if(lpParam[0] == 1) // admin, operator
		{
			m_nAuthentication = ADMINISTRATOR;
		}
		else if(lpParam[0] == 2) // guest
		{
			m_nAuthentication = GUEST;
		}
	}
	else if(lstrcmp(szCommandCode, "AGN") == 0)
	{
		BYTE  *lpParam = (BYTE  *)param1;
		BYTE byAlarmIn = (BYTE)lpParam[0];
		BYTE byAlarmOut = (BYTE)lpParam[1];
		memcpy( m_byAlarmIn, &byAlarmIn, sizeof(BYTE));
		memcpy( m_byAlarmOut, &byAlarmOut, sizeof(BYTE));

		TRACE( "%d %d", m_byAlarmIn, m_byAlarmOut );

	}
	else if(lstrcmp(szCommandCode, "RSM") == 0) // Response Motion Detect Setup
	{
		BYTE  *lpParam = (BYTE  *)param1;
		switch(lpParam[0])
		{
		case 0x40:	// Motion Detect/Tracking On/Off
			{

			}
			break;
		case 0x41:  // Detect area map(54) : PENTA
			{

			}
			break;
		case 0x42:   // Sensitivity
			{
				m_dwSensitivity = lpParam[1]; // sensitivity 0~7
			}
			break;
		case 0x43:    // Pixel difference threshold
			{

			}
			break;
		case 0x44:	// difference pixel count threshold
			{

			}
			break;
		case 0x45:
			{
	
			}
			break;
		case 0x46:
			{

			}
			break;
		case 0x47:
			{
		
			}
			break;
		case 0x48:
			{
				
			}
			break;
		case 0x4A:  // Detect area map
			{
				BYTE *lpMotionArea = &lpParam[1];
				BYTE MotionInfo[32*18];
				memset(MotionInfo, 0, sizeof(MotionInfo));
				long i = 0, j = 0, k = 0;
				for (i = 0; i < 18; i++)
				{
					for (j = 7, k = 0; j >= 0; j--, k++)
					{
						if((lpMotionArea[i*4 + 0] >> j) & 0x01)
						{
							MotionInfo[i*32 + k] = 1;
						}
						else
						{
							MotionInfo[i*32 + k] = 0;
						}				
					}
					for (j = 7, k = 0; j >= 0; j--, k++)
					{
						if((lpMotionArea[i*4 + 1] >> j) & 0x01)
						{
							MotionInfo[i*32 + k + 8] = 1;
						}
						else
						{
							MotionInfo[i*32 + k + 8] = 0;
						}
					}
					for (j = 7, k = 0; j >= 0; j--, k++)
					{
						if((lpMotionArea[i*4 + 2] >> j) & 0x01)
						{
							MotionInfo[i*32 + k + 16] = 1;
						}
						else
						{
							MotionInfo[i*32 + k + 16] = 0;
						}
					}
					for (j = 7, k = 0; j >= 0; j--, k++)
					{
						if((lpMotionArea[i*4 + 3] >> j) & 0x01)
						{
							MotionInfo[i*32 + k + 24] = 1;
						}
						else
						{
							MotionInfo[i*32 + k + 24] = 0;
						}
					}
				}
				m_Render->SetMotionInfo(MotionInfo, sizeof(MotionInfo));
			}
			break;
		default:
			break;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_RECV_VIDEO_CTRL_DATA(char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
	if( lstrcmp(szCommandCode, "CNS") == 0 )
	{
		// Real connection
		m_nVideoStatus = STATUS_CONNECTED;
	}
	else if( lstrcmp(szCommandCode, "LGS") == 0 )
	{
		m_nVideoStatus = STATUS_LOGON;
	}
	else if( lstrcmp(szCommandCode, "LGW") == 0 )
	{
		m_nVideoStatus = STATUS_LOGON_FAIL;
	}
	else if( lstrcmp(szCommandCode, "CLS") == 0  )
	{
		m_nVideoStatus = STATUS_LOGOFF;
	}
	else if( lstrcmp(szCommandCode, "STA") == 0  )
	{
		m_nVideoStatus = STATUS_LOGON;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_RECV_VIDEO_DATA(VIDEO_DATA_PACK *lpData, DWORD_PTR param1, DWORD_PTR param2)
{
	if(m_isFirstFrame)
	{
		if(lpData->m_nFrame_type != 0)
			return;
		m_isFirstFrame = FALSE;
	}

	if( lpData != NULL )
	{
		if( m_pRcvVideoData )
		{
			memcpy( m_pRcvVideoData, lpData, sizeof( VIDEO_DATA_PACK ) );
		}
	}

	if( (lpData->m_isCompMode != m_nCodecType && lpData->m_nFrame_type == 0) || lpData->m_nResolution_Id != m_nResolutionID )	
	{
		m_dwVideoFrameNum  = 0;
		m_dwVideoFrameSize = 0;
		m_dwVideoOffset    = 0;
		m_dwVideoSliceNum  = 0;

		m_nCodecType	= lpData->m_isCompMode;
		m_nResolutionID	= lpData->m_nResolution_Id;
		
		RefreshDecoder( lpData->m_isCompMode );
	}
	
	if( m_dwVideoSliceNum != lpData->m_nSlice_Num ) // drop packet
	{
		m_dwVideoFrameNum  = 0;
		m_dwVideoFrameSize = 0;
		m_dwVideoOffset    = 0;
		m_dwVideoSliceNum  = 0;
		return;
	}

	if(lpData->m_nSlice_Num == 0)
	{
		m_dwVideoFrameNum  = 0;
		m_dwVideoFrameSize = 0;
		m_dwVideoOffset    = 0;
		m_dwVideoSliceNum  = 0;
	
		m_dwVideoFrameSize = lpData->m_nFrame_Size;
		m_dwVideoFrameNum  = lpData->m_nFrame_Num;

		m_IsIFrame			= (lpData->m_nFrame_type == 0) ? 1 : 0;

		//TRACE( "%s(%ld)\n", lpData->m_nFrame_type ? "-------- P ----------" : "-------- I ----------", ::GetTickCount() );
	}

	if( lpData->m_szFrameData == NULL || m_lpVideoData == NULL )
		return;

	CopyMemory(m_lpVideoData + m_dwVideoOffset, lpData->m_szFrameData, lpData->m_nSlice_Size);
	m_dwVideoOffset += lpData->m_nSlice_Size;

	if( m_dwVideoOffset == m_dwVideoFrameSize && m_dwVideoFrameNum == lpData->m_nFrame_Num)		// complete packet
	{

		if( lpData->m_isCompMode == ctMJPEG_MD_PENTA || lpData->m_isCompMode == ctMPEG4_MD_PENTA )
		{
			DWORD dwNumberOfChannels=1;

			BYTE *m_pOut420DataA=(BYTE *)((((DWORD)m_pOutImageTemp+15)/16)*16);
			BYTE *m_pOutImageA=(BYTE *)((((DWORD)m_pOutImage+15)/16)*16);
			if(m_Decoder->DEC_VIDEO(m_lpVideoData + (9 + m_lpVideoData[8]), 
				m_pOut420DataA, m_dwVideoFrameSize-(9 + m_lpVideoData[8]), 
				&m_nWidth, &m_nHeight, &dwNumberOfChannels))
			{
				SIZE roi;
				roi.cx = m_nWidth;
				roi.cy = m_nHeight;

				ConvertColorFormat(m_pOut420DataA,CF_YUY2,m_pOutImageA,4*m_nWidth,RGB32bpp,roi,1);

				*m_IsDecodingSuccess = TRUE;
				
				if( m_pOutImage != NULL )
					m_Render->DrawImage(m_pOutImageA, m_nWidth, m_nHeight);
			}
			else
			{
				*m_IsDecodingSuccess = FALSE;
			}
		}
		else if( lpData->m_isCompMode == ctMJPEG_DM365 || lpData->m_isCompMode == ctH264_MD_DM365 )
		{
			// Only When channel value is 0, the vdeo stream is included motion infomation.
			if(lpData->m_nChannelInfo == 0)
			{
				m_dwMotionSize = 72;
				memcpy(m_lpMotionInfo, m_lpVideoData, m_dwMotionSize);
			}
			else
			{
				m_dwMotionSize = 0;
			}

			DWORD dwNumberOfChannels=1;
			BYTE *m_pOut420DataA=(BYTE *)((((DWORD)m_pOutImageTemp+15)/16)*16);
			BYTE *m_pOutImageA=(BYTE *)((((DWORD)m_pOutImage+15)/16)*16);

			if(m_Decoder->DEC_VIDEO(m_lpVideoData + m_dwMotionSize, 
				m_pOut420DataA, m_dwVideoFrameSize - m_dwMotionSize, &m_nWidth, &m_nHeight, &dwNumberOfChannels))
			{
				SIZE roi;
				roi.cx = m_nWidth;
				roi.cy = m_nHeight;
			
				ConvertColorFormat(m_pOut420DataA,CF_YUY2,m_pOutImageA,4*m_nWidth,RGB32bpp,roi,1);

				*m_IsDecodingSuccess = TRUE;

				if( m_pOutImage != NULL )
					m_Render->DrawImage(m_pOutImageA, m_nWidth, m_nHeight, m_lpMotionInfo, m_dwMotionSize);
			}
			else
			{
				*m_IsDecodingSuccess = FALSE;
			}
		}
		else if( lpData->m_isCompMode == ctMPEG4_MD_DM365 )
		{
			DWORD dwNumberOfChannels=1;
			BYTE *m_pOut420DataA=(BYTE *)((((DWORD)m_pOutImageTemp+15)/16)*16);
			BYTE *m_pOutImageA=(BYTE *)((((DWORD)m_pOutImage+15)/16)*16);
			if( !m_ISMPEG4DecodeInit )
			{
				SetVOLHeader( lpData->m_nResolution_Id );

				// MPEG4 ʱȭ (m_cVOLHeader) Decoding   .
				m_Decoder->DEC_VIDEO((BYTE *)m_cVOLHeader , m_pOut420DataA, 18, &m_nWidth, &m_nHeight, &dwNumberOfChannels);
			}

			if(m_Decoder->DEC_VIDEO(m_lpVideoData, m_pOut420DataA, m_dwVideoFrameSize, &m_nWidth, &m_nHeight, &dwNumberOfChannels) )
			{
				SIZE roi;
				roi.cx = m_nWidth;
				roi.cy = m_nHeight;
			
				ConvertColorFormat(m_pOut420DataA,CF_YUY2,m_pOutImageA,4*m_nWidth,RGB32bpp,roi,1);
				
				*m_IsDecodingSuccess = TRUE;

				if( m_pOutImage != NULL )
					m_Render->DrawImage(m_pOutImageA, m_nWidth, m_nHeight);

				m_ISMPEG4DecodeInit = TRUE;
			}
			else
			{
				m_ISMPEG4DecodeInit = FALSE;
				*m_IsDecodingSuccess = FALSE;
			}
		}
		else
		{
			DWORD dwNumberOfChannels=1;
			
			BYTE *m_pOut420DataA=(BYTE *)((((DWORD)m_pOutImageTemp+15)/16)*16);
			BYTE *m_pOutImageA=(BYTE *)((((DWORD)m_pOutImage+15)/16)*16);
			if(m_Decoder->DEC_VIDEO(m_lpVideoData , 
				m_pOut420DataA, m_dwVideoFrameSize, &m_nWidth, &m_nHeight, &dwNumberOfChannels))
			{
				SIZE roi;
				roi.cx = m_nWidth;
				roi.cy = m_nHeight;
			
				ConvertColorFormat(m_pOut420DataA,CF_YUY2,m_pOutImageA,4*m_nWidth,RGB32bpp,roi,1);
			
				*m_IsDecodingSuccess = TRUE;

				if( m_pOutImage != NULL )
					m_Render->DrawImage(m_pOutImageA, m_nWidth, m_nHeight);
			}
			else
			{
				*m_IsDecodingSuccess = FALSE;
			}
		}
		m_dwVideoFrameSize = 0;
		m_dwVideoOffset    = 0; 
		m_dwVideoFrameNum  = 0;
		m_dwVideoSliceNum  = 0;
	}
	else
	{
		m_dwVideoSliceNum++;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_RECV_AUDIO_SPEAKER_CTRL_DATA(char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
//	TRACE( "MicCtrl( %s )\n", szCommandCode );
	if( lstrcmp(szCommandCode, "CNS") == 0 )
	{
		// Real connection
		m_nAudioSpeakerStatus = STATUS_CONNECTED;
	}
	else if( lstrcmp(szCommandCode, "LGS") == 0 )
	{
		m_nAudioSpeakerStatus = STATUS_LOGON;
	}
	else if( lstrcmp(szCommandCode, "LGW") == 0 )
	{
		m_nAudioSpeakerStatus = STATUS_LOGON_FAIL;
	}
	else if( lstrcmp(szCommandCode, "CLS") == 0  )
	{
		m_nAudioSpeakerStatus = STATUS_LOGOFF;
	}
	else if( lstrcmp(szCommandCode, "STA") == 0  )
	{
		m_nAudioSpeakerStatus = STATUS_LOGON;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_RECV_AUDIO_SPEAKER_DATA(AUDIO_DATA_PACK *lpData)
{
	if( !m_bOnSpeaker || (m_hAudioDecoder == INVALID_HANDLE_VALUE ) )
	{
		m_nWaveOutBufIndex = 0;
		m_dwAudioFrameSize = 0;
		m_dwAudioOffset    = 0;

		return;
	}

	if(m_nAudioCodecType != lpData->m_isCompMode)
	{
		if( m_bOnSpeaker )
		{
			m_nAudioCodecType = lpData->m_isCompMode;
			StopAudioSpeaker();
			PlayAudioSpeaker(m_nAudioCodecType);
		}
	}

	if(m_dwAudioOffset == 0)
	{
		CTime time = CTime::GetCurrentTime();
		m_dwAudioFrameSize = lpData->m_nFrame_Size;
	}

	if(m_dwAudioFrameSize > m_dwAudioOffset)
	{
		CopyMemory(m_lpAudioSpeakerData + m_dwAudioOffset, lpData->m_szFrameData, lpData->m_nSlice_Size);
		m_dwAudioOffset += lpData->m_nSlice_Size;


		if(m_dwAudioOffset >= m_dwAudioFrameSize)
		{
			// decode
			if( m_nWaveOutBufIndex >= LEN_AUDIOOUT_WAVEFORMBUF )
				m_nWaveOutBufIndex = 0;



			DWORD			dwOutputByte;
			WAVEHDR* pWaveOutHdr = m_arpWaveOutHdr[m_nWaveOutBufIndex];

			if( pWaveOutHdr != NULL && m_dwAudioOffset == m_dwAudioFrameSize )
			{
				AUDG711DECODER_DECODE( m_hAudioDecoder, (char *)m_lpAudioSpeakerData, m_dwAudioOffset, pWaveOutHdr->lpData, dwOutputByte );
				
				pWaveOutHdr->dwBufferLength = dwOutputByte;
				m_nWaveOutBufIndex++;
				
				::waveOutWrite( m_hWaveOut, pWaveOutHdr, sizeof(WAVEHDR) );
			}
			
			m_dwAudioFrameSize = 0;
			m_dwAudioOffset    = 0;
		}

	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_RECV_AUDIO_MIC_CTRL_DATA(char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2)
{
//	TRACE( "MicCtrl( %s )\n", szCommandCode );
	if( lstrcmp(szCommandCode, "CNS") == 0 )
	{
		// Real connection
		m_nAudioMicStatus = STATUS_CONNECTED;
	}
	else if( lstrcmp(szCommandCode, "LGS") == 0 )
	{
		m_nAudioMicStatus = STATUS_LOGON;
	}
	else if( lstrcmp(szCommandCode, "LGW") == 0 )
	{
		m_nAudioMicStatus = STATUS_LOGON_FAIL;
	}
	else if( lstrcmp(szCommandCode, "CLS") == 0  )
	{
		m_nAudioMicStatus = STATUS_LOGOFF;
	}
	else if( lstrcmp(szCommandCode, "STA") == 0  )
	{
		m_nAudioMicStatus = STATUS_LOGON;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_ERROR_CTRL(int nErrorCode)
{
	switch(nErrorCode)
	{
	case _PROBE_SOCK_CONNECT_SUCCESS: 
		{
			m_IsControlConnected = TRUE;
		}
		break;
	case _PROBE_SOCK_CONNECT_FAILED:
	case _PROBE_SOCK_CONNECT_NOTAVAIL:
	case _PROBE_SOCK_CONNECT_FAULT:
	case _PROBE_SOCK_CONNECT_TIMEOUT:
	case _PROBE_SOCK_DISCONNECTED:
		{
			m_IsControlConnected = FALSE;
			m_nControlStatus	 = STATUS_NONE;	
		}	
		break;
	default:
		break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_ERROR_VIDEO(int nErrorCode)
{
	switch(nErrorCode)
	{
	case _PROBE_SOCK_CONNECT_SUCCESS:
		{
			m_IsVideoConnected = TRUE;
		}
		break;
	case _PROBE_SOCK_CONNECT_FAILED:
	case _PROBE_SOCK_CONNECT_NOTAVAIL:
	case _PROBE_SOCK_CONNECT_FAULT:
	case _PROBE_SOCK_CONNECT_TIMEOUT:
	case _PROBE_SOCK_DISCONNECTED:
		{
			m_IsVideoConnected = FALSE;
			m_nVideoStatus	   = STATUS_NONE;
		}
		break;
	case _PROBE_SOCK_STREAM_LOSS:		// Media Stream Receive Fail
	default:
		break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_ERROR_AUDIO_SPEAKER(int nErrorCode)
{
	switch(nErrorCode)
	{
	case _PROBE_SOCK_CONNECT_SUCCESS:
		{
			m_IsAudioSpeakerConnected = TRUE;
		}
		break;
	case _PROBE_SOCK_CONNECT_FAILED:
	case _PROBE_SOCK_CONNECT_NOTAVAIL:
	case _PROBE_SOCK_CONNECT_FAULT:
	case _PROBE_SOCK_CONNECT_TIMEOUT:
	case _PROBE_SOCK_DISCONNECTED:
		{
			m_IsAudioSpeakerConnected  = FALSE;
			m_nAudioSpeakerStatus	   = STATUS_NONE;
		}
		break;
	case _PROBE_SOCK_STREAM_LOSS:		// Media Stream Receive Fail
	default:
		break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ON_ERROR_AUDIO_MIC(int nErrorCode)
{
//	TRACE( "MicError( %d )\n", nErrorCode );
	switch(nErrorCode)
	{
	case _PROBE_SOCK_CONNECT_SUCCESS:
		{
			m_IsAudioMicConnected = TRUE;
		}
		break;
	case _PROBE_SOCK_CONNECT_FAILED:
	case _PROBE_SOCK_CONNECT_NOTAVAIL:
	case _PROBE_SOCK_CONNECT_FAULT:
	case _PROBE_SOCK_CONNECT_TIMEOUT:
	case _PROBE_SOCK_DISCONNECTED:
		{
			m_IsAudioMicConnected  = FALSE;
			m_nAudioMicStatus	   = STATUS_NONE;
		}
		break;
	case _PROBE_SOCK_STREAM_LOSS:		// Media Stream Receive Fail
	default:
		break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Construction/Destruction
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CLiveChannel::CLiveChannel()
{
	m_hConnection			= INVALID_HANDLE_VALUE;
	
	m_lpVideoData		= new BYTE[1024*1024];
	m_lpMotionInfo		= new BYTE[1024];
	m_dwMotionSize      = 0;
	
	m_dwVideoOffset		= 0;
	m_dwVideoFrameSize	= 0;
	
	m_nCodecType		= 0;
	
	m_nWidth			= 0;
	m_nHeight			= 0;
	
	m_pOutImage		= new BYTE[1920*1080*4+128];
	m_pOutImageTemp	= new BYTE[1920*1080*4+128];
	
	m_dwVideoSliceNum	= 0;
	m_dwVideoFrameNum	= 0;
	
	m_IsControlConnected		= FALSE;
	m_IsVideoConnected			= FALSE;
	m_IsAudioSpeakerConnected	= FALSE;
	m_IsAudioMicConnected		= FALSE;
	
	m_nControlStatus		= STATUS_NONE;
	m_nVideoStatus			= STATUS_NONE;
	m_nAudioSpeakerStatus	= STATUS_NONE;
	m_nAudioMicStatus		= STATUS_NONE;
	
	m_bEventAlarmInput1		= FALSE;
	m_bEventAlarmInput2		= FALSE;
	m_bEventMotion			= FALSE;
	m_nMotionMode			= ALL_OFF;
	
	m_nAuthentication		= ADMINISTRATOR;

	m_pRcvVideoData			= NULL;
	
	m_Decoder				= new CVideoCodec( CODECINDEX_MJPEG );
	m_Render				= new CVideoView();
	
	m_IsIFrame				= FALSE;
	m_dwIFrameNumber		= 0;
	
	m_IsDecodingSuccess		= NULL;
	
	m_wPTZSpeed				= 500;
	m_pwPan					= NULL;
	m_pwTilt				= NULL;
	m_pwZoom				= NULL;

	m_byAlarmIn				= NULL;
	m_byAlarmOut			= NULL;

	m_ISMPEG4DecodeInit		= FALSE;
	m_cVOLHeader			= NULL;
	
	m_nResolutionID			= 0;
	m_dwCtrlCode			= 0;

	m_dwSensitivity         = 5;
	//..................................................

	m_AudiodataPack			= new AUDIO_DATA_PACK();

	m_dwAudioOffset			= 0;
	m_dwAudioFrameSize		= 0;
	
	m_nWaveOutBufIndex		= 0;
	m_lpAudioSpeakerData	= NULL;
	m_hAudioDecoder			= INVALID_HANDLE_VALUE;
	m_bOnSpeaker			= FALSE;
	m_hWaveOut				= NULL;	
	m_nAudioCodecType       = -1;
	::memset(m_arpWaveOutHdr, 0, LEN_AUDIOOUT_WAVEFORMBUF * sizeof(WAVEHDR*));

	m_nWaveInBufIndex		= 0;
	m_lpAudioMicData		= NULL;
	m_hAudioEncoder			= INVALID_HANDLE_VALUE;
	m_hWaveIn				= NULL;
	m_dwFrameNum			= 0;
	::memset(m_arpWaveInHdr, 0, LEN_AUDIOIN_WAVEFORMBUF * sizeof(WAVEHDR*));

	memset(&m_CameraConfig, 0, sizeof(m_CameraConfig));

	m_bRecording			= FALSE;

	m_isFirstFrame          = TRUE;

	InitAudioSpeaker();
	InitAudioMic();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CLiveChannel::~CLiveChannel()
{
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::End()
{
	if( m_lpVideoData != NULL )
	{
		delete [] m_lpVideoData;
		m_lpVideoData = NULL;
	}

	if(m_lpMotionInfo)
	{
		delete [] m_lpMotionInfo;
		m_lpMotionInfo = NULL;
	}
	
    if ( m_Render )
    {
        delete m_Render ;
        m_Render = NULL ;
    }

	if( m_Decoder != NULL )
	{
		delete m_Decoder;
		m_Decoder = NULL;
	}
	
	if( m_pOutImage != NULL )
	{
		delete [] m_pOutImage;
		m_pOutImage = NULL;
	}
	
	if( m_pOutImageTemp != NULL )
	{
		delete [] m_pOutImageTemp;
		m_pOutImageTemp = NULL;
	}
	
	if( m_cVOLHeader )
	{
		delete [] m_cVOLHeader;
		m_cVOLHeader = NULL;
	}

	if( m_AudiodataPack )
	{
		delete [] m_AudiodataPack;
		m_AudiodataPack = NULL;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::InitAudioSpeaker()
{
	if( !m_lpAudioSpeakerData )
		m_lpAudioSpeakerData = new BYTE[4096];

	if( m_hAudioDecoder == INVALID_HANDLE_VALUE )
		m_hAudioDecoder	= AUDG711DECODER_INIT();

	m_nAudioCodecType       = -1;
	m_dwAudioOffset			= 0;
	m_dwAudioFrameSize		= 0;
	m_nWaveOutBufIndex		= 0;
	m_hWaveOut				= NULL;
		
	m_bOnSpeaker			= FALSE;
	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::PlayAudioSpeaker(int nCodecType)
{
	//..................................................
	if(nCodecType == AUDIO_CODEC_G711_16K)
	{
		m_WaveOutFormatData.wFormatTag		= WAVE_FORMAT_PCM;
		m_WaveOutFormatData.nChannels		= AT_MONO;
		m_WaveOutFormatData.nSamplesPerSec	= AUDIO_16KSAMPLE_PER_SEC;
		m_WaveOutFormatData.wBitsPerSample	= AUDIO_BITS_FOR_SAMPLE;
	}
	else if(nCodecType == AUDIO_CODEC_G711_8K)
	{
		m_WaveOutFormatData.wFormatTag		= WAVE_FORMAT_PCM;
		m_WaveOutFormatData.nChannels		= AT_MONO;
		m_WaveOutFormatData.nSamplesPerSec	= AUDIO_8KSAMPLE_PER_SEC;
		m_WaveOutFormatData.wBitsPerSample	= AUDIO_BITS_FOR_SAMPLE;
	}

	m_WaveOutFormatData.nBlockAlign		= (m_WaveOutFormatData.wBitsPerSample / 8) * m_WaveOutFormatData.nChannels; 
	m_WaveOutFormatData.nAvgBytesPerSec	= m_WaveOutFormatData.nSamplesPerSec * m_WaveOutFormatData.nChannels * m_WaveOutFormatData.nBlockAlign;
	m_WaveOutFormatData.cbSize			= 0;
	
	if (MMSYSERR_NOERROR != ::waveOutOpen(&m_hWaveOut, WAVE_MAPPER, &m_WaveOutFormatData, (DWORD)NULL, (DWORD)NULL, (DWORD)CALLBACK_NULL))
	{
		ASSERT(0);
	}
	
	for( int i = 0; i < LEN_AUDIOOUT_WAVEFORMBUF; i++ )
	{
		m_arpWaveOutHdr[i] = (WAVEHDR*) ::HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(WAVEHDR) + AUDIO_DATABLOCK_SIZE);
		m_arpWaveOutHdr[i]->lpData = (LPSTR) (m_arpWaveOutHdr[i] + 1);
		m_arpWaveOutHdr[i]->dwBufferLength = AUDIO_DATABLOCK_SIZE;
		
		::waveOutPrepareHeader( m_hWaveOut, m_arpWaveOutHdr[i], sizeof(WAVEHDR) );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::StopAudioSpeaker()
{
	if( m_hWaveOut )
	{
		::waveOutReset( m_hWaveOut );
		
		for (int i = 0; i < LEN_AUDIOOUT_WAVEFORMBUF; i++)
		{
			::waveOutUnprepareHeader( m_hWaveOut, m_arpWaveOutHdr[i], sizeof(WAVEHDR) );
			
			::HeapFree(::GetProcessHeap(), 0, m_arpWaveOutHdr[i]);
			m_arpWaveOutHdr[i] = NULL;
		}
		
		::waveOutClose( m_hWaveOut );
		m_hWaveOut = NULL;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::TerminateAudioSpeaker()
{
	if( m_lpAudioSpeakerData )
	{
		delete [] m_lpAudioSpeakerData;
		m_lpAudioSpeakerData = NULL;
	}

	if( m_hAudioDecoder != INVALID_HANDLE_VALUE )
    {
		AUDG711DECODER_END( m_hAudioDecoder );
        m_hAudioDecoder = INVALID_HANDLE_VALUE ;
    }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::AudioSpeakerOn( BOOL bFlag )
{
	m_bOnSpeaker = bFlag;
	if( m_bOnSpeaker )
		PlayAudioSpeaker();
	else
		StopAudioSpeaker();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::InitAudioMic()
{
	if( !m_lpAudioMicData )
		m_lpAudioMicData = new BYTE[4096];

	if( m_hAudioEncoder == INVALID_HANDLE_VALUE )
		m_hAudioEncoder	= AUDADPCMENCODER_INIT();

	m_nWaveInBufIndex		= 0;
	m_hWaveIn				= NULL;
	
	m_WaveInFormatData.wFormatTag		= WAVE_FORMAT_PCM;
	m_WaveInFormatData.nChannels		= AT_MONO;
	m_WaveInFormatData.nSamplesPerSec	= AUDIO_CODEC_G711_16K;
	m_WaveInFormatData.wBitsPerSample	= AUDIO_BITS_FOR_SAMPLE;
	m_WaveInFormatData.nBlockAlign		= m_WaveInFormatData.wBitsPerSample / 8 * m_WaveInFormatData.nChannels;		// be equal to the product of nChannels and wBitsPerSample divided by 8 (bits per byte). 
	m_WaveInFormatData.nAvgBytesPerSec	= m_WaveInFormatData.nSamplesPerSec * m_WaveInFormatData.nBlockAlign;
	m_WaveInFormatData.cbSize			= 0;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::PlayAudioMic()
{
	m_bRecording = TRUE;

	if (MMSYSERR_NOERROR != ::waveInOpen(&m_hWaveIn, WAVE_MAPPER, &m_WaveInFormatData, (DWORD)AudioSendProc, (DWORD)this, CALLBACK_FUNCTION))
	{
		AfxMessageBox("Open Device Failed!");
	}	
	
	for (int i = 0; i < LEN_AUDIOIN_WAVEFORMBUF; i++)
	{
		m_arpWaveInHdr[i] = (WAVEHDR*) ::HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(WAVEHDR) + AUDIO_DATABLOCK_SIZE);
		m_arpWaveInHdr[i]->lpData = (LPSTR) (m_arpWaveInHdr[i] + 1);
		m_arpWaveInHdr[i]->dwBufferLength = AUDIO_DATABLOCK_SIZE;
		
		if( MMSYSERR_INVALHANDLE == ::waveInPrepareHeader(m_hWaveIn, m_arpWaveInHdr[i], sizeof(WAVEHDR)) )
			AfxMessageBox("Prepared Failed!");
		
		if(MMSYSERR_NOERROR != ::waveInAddBuffer(m_hWaveIn, m_arpWaveInHdr[i], sizeof(WAVEHDR)) )
			AfxMessageBox("Add Buffer Failed!");
	}
	
	if( MMSYSERR_NOERROR != ::waveInStart(m_hWaveIn) )
		AfxMessageBox("WaveIn Start Failed!");
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::StopAudioMic()
{
	m_bRecording = FALSE;

	if( m_hWaveIn )
	{
		::waveInStop( m_hWaveIn );
		::waveInReset(m_hWaveIn);
	
		for (int i = 0; i < LEN_AUDIOIN_WAVEFORMBUF; i++)
		{
			::waveInUnprepareHeader(m_hWaveIn, m_arpWaveInHdr[i], sizeof(WAVEHDR));
			::HeapFree(::GetProcessHeap(), 0, m_arpWaveInHdr[i]);
			m_arpWaveInHdr[i] = NULL;
		}
		
		::waveInClose(m_hWaveIn);
		m_hWaveIn = NULL;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::TerminateAudioMic()
{
	if( m_lpAudioMicData )
	{
		delete [] m_lpAudioMicData;
		m_lpAudioMicData = NULL;
	}

	if( m_hAudioEncoder != INVALID_HANDLE_VALUE )
    {
		AUDADPCMENCODER_END( m_hAudioEncoder );
        m_hAudioEncoder = INVALID_HANDLE_VALUE ;
    }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::EncodeAudio( WAVEHDR *pWaveInHdr )
{
	DWORD			dwOutputByte;
	DWORD			dwSliceNum = 0;

	if( m_hAudioEncoder != INVALID_HANDLE_VALUE )
	{
		if( AUDG711ENCODER_ENCODE( m_hAudioEncoder, (char *)pWaveInHdr->lpData, pWaveInHdr->dwBufferLength, (char *)m_lpAudioMicData, dwOutputByte ) )
		{
			m_dwFrameNum++;
			if(m_dwFrameNum > 600000)
			{
				m_dwFrameNum = 1;
			}
			int nPos=0;
			DWORD dwLeftSize = dwOutputByte;
			//TRACE( "FrameNum(%d), Output(%d)\n", m_dwFrameNum, dwOutputByte );
			while(dwLeftSize > 0)
			{
				DWORD dwSendSize=0;
				if(dwLeftSize > MAX_VIDEO_BUFFER_SIZE)
				{
					dwSendSize = MAX_VIDEO_BUFFER_SIZE;
				}
				else
				{
					dwSendSize = dwLeftSize;
				}
				
				m_AudiodataPack->m_nFrame_Size = dwOutputByte;
				m_AudiodataPack->m_nSlice_Size = dwSendSize;
				m_AudiodataPack->m_nFrame_Num  = m_dwFrameNum;
				m_AudiodataPack->m_isCompMode  = 1;
				m_AudiodataPack->m_nSlice_Num  = dwSliceNum++;
				CopyMemory(m_AudiodataPack->m_szFrameData, m_lpAudioMicData+nPos, dwSendSize);
				_PROBENET_AUDIOSENDER_SENDPACK( m_hConnection, m_AudiodataPack );
				dwLeftSize  -= dwSendSize;
				nPos		+= dwSendSize;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::OnConnect( char *szAddr, char *szControlPort, char *szVideoPort, char *szAudioTPort, char *szAudioRPort, char *szUserId, char *szPasswd )
{
	if( m_hConnection != INVALID_HANDLE_VALUE )
	{
		StopAudioSpeaker();
		TerminateAudioSpeaker();
		StopAudioMic();
		TerminateAudioMic();

		//_PROBENET_CONNECTION_DISCONNECT( m_hConnection, _CONTROL_SOCK | _VIDEO_SOCK | _AUDIO_SOCK );
		_PROBENET_CONNECTION_DISCONNECTALL( m_hConnection );
		_PROBENET_CONNECTION_END( m_hConnection );
		m_hConnection = INVALID_HANDLE_VALUE;
	}

	CONNECTION_INFO ConnectionInfo;
	DWORD dwMaskCreatingSocks = _CONTROL_SOCK | _VIDEO_SOCK | _AUDIO_SOCK | _AUDIOSEND_SOCK;
	memset(&ConnectionInfo, 0, sizeof(ConnectionInfo));
	lstrcpy(ConnectionInfo.m_szAddress, szAddr);
	lstrcpy(ConnectionInfo.m_szUserId, szUserId);
	lstrcpy(ConnectionInfo.m_szPassWd, szPasswd);
	ConnectionInfo.m_wControlPort	= (WORD)atoi(szControlPort);
	ConnectionInfo.m_wVideoPort		= (WORD)atoi(szVideoPort);
	ConnectionInfo.m_wAudioPort		= (WORD)atoi(szAudioTPort);
	ConnectionInfo.m_wMikePort		= (WORD)atoi(szAudioRPort);

	m_dwAudioOffset		= 0;
	m_dwAudioFrameSize	= 0;
	m_dwVideoOffset		= 0;
	m_dwVideoFrameSize	= 0;

	m_hConnection = _PROBENET_CONNECTION_INIT( &ConnectionInfo, dwMaskCreatingSocks );
	if( m_hConnection != INVALID_HANDLE_VALUE )
	{
		_PROBENET_CONNECTION_SETCTRLCALLFUNC( m_hConnection,
			CLiveChannel::_ON_RECV_CTRL_DATA, 
			CLiveChannel::_ON_ERROR_CTRL, 
			(HANDLE)this);
		_PROBENET_CONNECTION_SETSTREAMCALLFUNC( m_hConnection,
			CLiveChannel::_ON_RECV_VIDEO_DATA, 
			CLiveChannel::_ON_RECV_AUDIO_SPEAKER_DATA,
			CLiveChannel::_ON_RECV_VIDEO_CTRL_DATA,
			CLiveChannel::_ON_RECV_AUDIO_SPEAKER_CTRL_DATA,
			CLiveChannel::_ON_ERROR_VIDEO,
			CLiveChannel::_ON_ERROR_AUDIO_SPEAKER,
			(HANDLE)this);
		_PROBENET_CONNECTION_SETAUDIOSENDERCALLFUNC( m_hConnection,
			CLiveChannel::_ON_RECV_AUDIO_MIC_CTRL_DATA, 
			CLiveChannel::_ON_ERROR_AUDIO_MIC, 
			(HANDLE)this);
		//_PROBENET_CONNECTION_CONNECT( m_hConnection, _CONTROL_SOCK|_VIDEO_SOCK|_AUDIO_SOCK ); - All Connect
		_PROBENET_CONNECTION_CONNECT( m_hConnection, _CONTROL_SOCK );	// ι° 
	}

	//..................................................
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::OnDisConnect()
{
	StopAudioSpeaker();
	TerminateAudioSpeaker();
	StopAudioMic();
	TerminateAudioMic();
	
	if( m_hConnection != INVALID_HANDLE_VALUE )
	{
		//_PROBENET_CONNECTION_DISCONNECT( m_hConnection, _CONTROL_SOCK | _VIDEO_SOCK | _AUDIO_SOCK | _AUDIOSEND_SOCK ); // 1° 
		_PROBENET_CONNECTION_DISCONNECTALL( m_hConnection );
		_PROBENET_CONNECTION_END( m_hConnection );
		m_hConnection = INVALID_HANDLE_VALUE;
		
		m_nControlStatus	= STATUS_LOGOFF;
		m_nVideoStatus		= STATUS_LOGOFF;
		m_nAudioSpeakerStatus = STATUS_LOGOFF;
		m_nAudioMicStatus	= STATUS_LOGOFF;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::RefreshDecoder( int nCodecType )
{
	if( m_Decoder != NULL )
	{
		delete m_Decoder;
		m_Decoder = NULL;
	}
	
	if( nCodecType == ctMJPEG_MD_PENTA || nCodecType == ctMJPEG_DM365 )
		m_Decoder = new CVideoCodec( CODECINDEX_MJPEG );
	else if( nCodecType == ctMPEG4_MD_PENTA || nCodecType == ctMPEG4_MD_DM365 )
		m_Decoder = new CVideoCodec( CODECINDEX_MPEG4 );
	else if( nCodecType == ctH264_MD_DM365 )
		m_Decoder = new CVideoCodec( CODECINDEX_H264 );
	else
		m_Decoder = new CVideoCodec( CODECINDEX_H264 );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::SetMotionDetectionMode( int nMode )
{
	m_nMotionMode = nMode;
	if( m_hConnection != INVALID_HANDLE_VALUE )
	{
		BYTE  Param[2];
		DWORD dwParamSize=0;
		
		Param[0]	= 0x40;	
		Param[1]	= (char)nMode;
		dwParamSize = sizeof(BYTE)*2;

		//TRACE( "%s\n", (nMode) ? "Motion On" : "Motion Off"  );
		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, MOTION_MODE_COMMAND_CODE, Param, dwParamSize);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::SetPTZSpeed( WORD wSpeed )
{
	m_wPTZSpeed = wSpeed;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::SetPTZMove( int nPan, int nTilt, double nZoom )
{
	if( ( m_hConnection != INVALID_HANDLE_VALUE ) && m_IsControlConnected )
	{
		BYTE  Param[7];
		DWORD dwParamSize=0;

		::memset(Param, 0, 7);

		Param[0] = PTZ_MCO;
		Param[1] = (BYTE)(( nPan ) & 0xFF );
		Param[2] = (BYTE)(( nPan >> 8 ) & 0xFF );
				
		Param[3] = (BYTE)(( nTilt ) & 0xFF );
		Param[4] = (BYTE)(( nTilt >> 8 ) & 0xFF );
		
		Param[5] = (BYTE)(( (int)(nZoom) ) & 0xFF );
		Param[6] = (BYTE)(( (int)(nZoom) >> 8 ) & 0xFF );

		dwParamSize = sizeof(BYTE)*7;

		if( m_hConnection != INVALID_HANDLE_VALUE )
			_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
	}
}

void CLiveChannel::SaveMotionArea()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE MotionArea[32*18];
		memset(MotionArea, 0, sizeof(MotionArea));
		DWORD dwMotionSize = sizeof(MotionArea);
		if(m_Render->GetMotionInfo(MotionArea , dwMotionSize))
		{
			DWORD dwParamSize=0;
			BYTE  Param[72+1];
			memset(Param, 0, sizeof(Param));
			dwParamSize = sizeof(Param);
			
			Param[0]	= 0x4A;
			BYTE *pMotionArea = &Param[1];
			memset(pMotionArea, 0 ,72);
			long i = 0, j = 0, k = 0;
			for (i = 0; i < 18; i++)
			{
				for (j = 7, k = 0; j >= 0; j--, k++)
				{
					if(MotionArea[i*32 + k])
					{
						pMotionArea[i*4 + 0] |= 0x01<<j;
					}				
				}
				for (j = 7, k = 0; j >= 0; j--, k++)
				{
					if(MotionArea[i*32 + k + 8])
					{
						pMotionArea[i*4 + 1] |= 0x01<<j;
					}
				}
				for (j = 7, k = 0; j >= 0; j--, k++)
				{
					if(MotionArea[i*32 + k + 16])
					{
						pMotionArea[i*4 + 2] |= 0x01<<j;
					}
				}
				for (j = 7, k = 0; j >= 0; j--, k++)
				{
					if(MotionArea[i*32 + k + 24])
					{
						pMotionArea[i*4 + 3] |= 0x01<<j;
					}
				}
			}			
			
			_PROBENET_CTRL_SENDCOMMAND( m_hConnection, MOTION_MODE_COMMAND_CODE, Param, dwParamSize );			
		}
	}
}
void CLiveChannel::SaveMotionSensitivity(int nValue)
{
	DWORD dwSensitivity = 0;
	if(nValue == 0)
	{
		dwSensitivity = 6;
	}
	else if(nValue == 1)
	{
		dwSensitivity = 5;
	}
	else if(nValue == 2)
	{
		dwSensitivity = 4;
	}
	DWORD dwParamSize=0;
	BYTE  Param[72+1];
	memset(Param, 0, sizeof(Param));
	dwParamSize = 2*sizeof(BYTE);
	Param[0] = 0x42;
	Param[1] = (BYTE)dwSensitivity;
	_PROBENET_CTRL_SENDCOMMAND( m_hConnection, MOTION_MODE_COMMAND_CODE, Param, dwParamSize );
}
int  CLiveChannel::GetMotionSensitivity()
{
	int nValue = 0;
	if(m_dwSensitivity == 6)
	{
		nValue = 0;
	}
	else if(m_dwSensitivity == 5)
	{
		nValue = 1;	
	}
	if(m_dwSensitivity == 4)
	{
		nValue = 2;
	}
	return nValue;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::GetPTZCoordinates()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE) && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_GETPTZPOS;
		Param[1]	= 0;
		Param[2]	= 0;
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CLiveChannel::SetEncoderSetupInfo( ENCODE_SETUP_INFO *lpData )
{
	if(m_hConnection ==  INVALID_HANDLE_VALUE)
		return -1;

	return _PROBENET_CONNECTION_SETENCODESETUPINFO( m_hConnection, lpData );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CLiveChannel::GetEncoderSetupInfo( int nChannel, ENCODE_SETUP_INFO *lpData, BOOL bRefreshData )
{
	if(m_hConnection ==  INVALID_HANDLE_VALUE)
		return FALSE;

	return _PROBENET_CONNECTION_GETENCODESETUPINFO( m_hConnection, nChannel, lpData, bRefreshData );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::GetAlarmInOutStatus()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE) && m_IsControlConnected )
	{
		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, ALARM_INOUT_COMMAND_CODE, NULL, 0 );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::SetOutput( BOOL bOn, int nOutput )
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE) && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_SET_DOUT ;
		Param[1]	= (BYTE)( 1 << nOutput );
        Param[2]	= bOn ? 1 : 0 ;
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::SetVOLHeader( int nResolutionIndex )
{
	if( !m_cVOLHeader )
	{
		m_cVOLHeader = new char[18];
	}

	switch( nResolutionIndex )
	{
	case 8:	 {	Make_header( m_cVOLHeader, WIDTH_1080i,		HEIGHT_1080i ); } break;
	case 9:	 {	Make_header( m_cVOLHeader, WIDTH_720p,		HEIGHT_720p ); } break;
	case 10: {	Make_header( m_cVOLHeader, WIDTH_D1_HD,		HEIGHT_4CIF_PAL ); } break;
	case 11: {	Make_header( m_cVOLHeader, WIDTH_D1_HD,		HEIGHT_4CIF_NTSC ); } break;
	case 12: {	Make_header( m_cVOLHeader, WIDTH_D1_HD,		HEIGHT_HALF_D1_PAL ); } break;
	case 13: {	Make_header( m_cVOLHeader, WIDTH_D1_HD,		HEIGHT_HALF_D1_NTSC ); } break;
	case 14: {	Make_header( m_cVOLHeader, WIDTH_4CIF_SD,	HEIGHT_4CIF_PAL ); } break;
	case 15: {	Make_header( m_cVOLHeader, WIDTH_4CIF_SD,	HEIGHT_4CIF_NTSC ); } break;
	case 16: {	Make_header( m_cVOLHeader, WIDTH_4CIF_SD,	HEIGHT_HALF_4CIF_PAL ); } break;
	case 17: {	Make_header( m_cVOLHeader, WIDTH_4CIF_SD,	HEIGHT_HALF_4CIF_NTSC ); } break;
	case 18: {	Make_header( m_cVOLHeader, WIDTH_VGA,		HEIGHT_VGA ); } break;
	case 19: {	Make_header( m_cVOLHeader, WIDTH_CIF,		HEIGHT_CIF_PAL ); } break;
	case 20: {	Make_header( m_cVOLHeader, WIDTH_CIF,		HEIGHT_CIF_NTSC ); } break;
	case 21: {	Make_header( m_cVOLHeader, WIDTH_QVGA,		HEIGHT_QVGA ); } break;
	case 22: {	Make_header( m_cVOLHeader, WIDTH_QCIF,		HEIGHT_QCIF_PAL ); } break;
	case 23: {	Make_header( m_cVOLHeader, WIDTH_QCIF,		HEIGHT_QCIF_NTSC ); } break;
	case 24: {	Make_header( m_cVOLHeader, WIDTH_QQVGA,		HEIGHT_QQVGA ); } break;
	default:break;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CLiveChannel::Make_header( char *pVOLHeader, int width, int height )
{
	char	*vidBits = pVOLHeader;
	int		vopTimeIncr=1000;
	int	size = 18;

	memset(vidBits, 0 , 18);

	// video_object_start_code
	vidBits[0]= 0x00; vidBits[1]= 0x00; vidBits[2]= 0x01; vidBits[3]= 0x01;

	// video_object_layer_start_code
	vidBits[4]= 0x00; vidBits[5]= 0x00; vidBits[6]= 0x01; vidBits[7]= 0x20;

	// random_accessible_vol + video_object_type_indication + is_object_layer_identifier +
	// aspect_ratio_info + vol_control_parameters + video_object_layer_shape + marker_bit
	vidBits[8]= 0x00; vidBits[9]= (char)0x84; vidBits[10]= 0x40; 

	vidBits[10]= (vidBits[10] & 0xC0) | ((vopTimeIncr >> 10) & 0x3f); 
	vidBits[11]= ((vopTimeIncr >> 2) & 0xff);
	vidBits[12]= ((vopTimeIncr & 0x03)<<6) | (1<<5) | (0<<4) | (1<<3) | ((width>>10) & 0x7);
	vidBits[13]= ((width>>2) & 0xff);
	vidBits[14]= ((width & 0x3)<<6) | (1<<5) | ((height>>8) & 0x1f);
	vidBits[15]= (height&0xff);

	// marker_bit + interlaced + obmc_disable + sprite => 4bit
	// not_8_bit + quant_type + complexity_estimation_disable + resync_maker_disable => 4bit
	vidBits[16]= (char)0xA2;
	vidBits[17]= 0x1F;

	return size;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonLeftUp()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_MLU;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_MLU;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonUp()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_PTU;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_PTU;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonRightup()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_MRU;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_MRU;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonLeft()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_PTL;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_PTL;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonRight()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_PTR;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_PTR;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonLeftdown()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_MLD;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_MLD;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonDown()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_PTD;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_PTD;
	}	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonRightdown()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_MRD;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_MRD;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonStop()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[1];
		DWORD dwParamSize=0;
		
		//Edit by lsm. 20100617 : Lion, Prob⿡ PTZ Stop  41 ٲ. 
		if( m_dwCtrlCode == PTZ_PTU || m_dwCtrlCode == PTZ_PTD || m_dwCtrlCode == PTZ_PTL || m_dwCtrlCode == PTZ_PTR ||
			m_dwCtrlCode == PTZ_MRU || m_dwCtrlCode == PTZ_MRD || m_dwCtrlCode == PTZ_MLD || m_dwCtrlCode == PTZ_MLU )
		{
			Param[0]	= PTZ_STOP;
			dwParamSize = sizeof(BYTE);

			_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		}
		else if(m_dwCtrlCode == PTZ_ZMT || m_dwCtrlCode == PTZ_ZMW)
		{
			Param[0]	= PTZ_STT;
			dwParamSize = sizeof(BYTE);

			_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );

		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonZoomIn()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_ZMT;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );

		m_dwCtrlCode = PTZ_ZMT;

	}	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ButtonZoomOut()
{
	if( (m_hConnection !=  INVALID_HANDLE_VALUE)  && m_IsControlConnected )
	{
		BYTE  Param[3];
		DWORD dwParamSize=0;
		
		Param[0]	= PTZ_ZMW;
		Param[1]	= (BYTE)(m_wPTZSpeed & 0xFF);
		Param[2]	= (m_wPTZSpeed >> 8 );
		dwParamSize = sizeof(BYTE)*3;

		_PROBENET_CTRL_SENDCOMMAND( m_hConnection, PTZ_COMMAND_CODE, Param, dwParamSize );
		m_dwCtrlCode = PTZ_ZMW;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ConnectVideo( BOOL bConnect )
{
	if(m_hConnection ==  INVALID_HANDLE_VALUE) 
		return;

	if( bConnect )
		_PROBENET_CONNECTION_CONNECT( m_hConnection, _VIDEO_SOCK );
	else
		_PROBENET_CONNECTION_DISCONNECT( m_hConnection, _VIDEO_SOCK );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ConnectSpeaker( BOOL bConnect )
{
	if(m_hConnection ==  INVALID_HANDLE_VALUE) 
		return;

	if( bConnect )
	{
		InitAudioSpeaker();
		PlayAudioSpeaker();
		_PROBENET_CONNECTION_CONNECT( m_hConnection, _AUDIO_SOCK );
	}
	else
	{
		StopAudioSpeaker();
		TerminateAudioSpeaker();
		_PROBENET_CONNECTION_DISCONNECT( m_hConnection, _AUDIO_SOCK );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveChannel::ConnectMic( BOOL bConnect )
{
	if(m_hConnection ==  INVALID_HANDLE_VALUE) 
		return;

	if( bConnect )
	{
		InitAudioMic();
		PlayAudioMic();
		_PROBENET_CONNECTION_CONNECT( m_hConnection, _AUDIOSEND_SOCK );
	}
	else
	{
		StopAudioMic();
		TerminateAudioMic();
		_PROBENET_CONNECTION_DISCONNECT( m_hConnection, _AUDIOSEND_SOCK );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Construction/Destruction
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CLiveObject::CLiveObject()
{
	m_ChannelInfo = new CLiveChannel();
	
	_PROBENET_INIT();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CLiveObject::~CLiveObject()
{

}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::OnDestroy()
{
	m_ChannelInfo->End();

	// Finalize PROBE API
	_PROBENET_END();

	if( m_ChannelInfo )
	{
		delete m_ChannelInfo ;
		m_ChannelInfo = NULL;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::OnConnect( char *szAddr, char *szControlPort, char *szVideoPort, char *szAudioTPort, char *szAudioRPort, char *szUserId, char *szPasswd )
{
	m_ChannelInfo->OnConnect( szAddr, szControlPort, szVideoPort, szAudioTPort, szAudioRPort, szUserId, szPasswd );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::OnDisConnect()
{
	m_ChannelInfo->OnDisConnect();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::SetClientScreen( int nChannel, HWND hWnd, int x, int y, DWORD dwWWidth, DWORD dwWHeight )
{
	m_ChannelInfo->m_Render->Init( hWnd, dwWWidth, dwWHeight );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::SetConnectStream( int nChannel, VIDEO_DATA_PACK *pVideoData, BOOL *pIsDecodingSuccess, WORD *pwPan, WORD *pwTilt, WORD *pwZoom, 
								   BYTE *byAlarmIn, BYTE *byAlarmOut )
{
	if( !m_ChannelInfo->m_pRcvVideoData )
	{
		m_ChannelInfo->m_pRcvVideoData		= pVideoData;
		m_ChannelInfo->m_IsDecodingSuccess	= pIsDecodingSuccess;
		m_ChannelInfo->m_pwPan				= pwPan;
		m_ChannelInfo->m_pwTilt				= pwTilt;
		m_ChannelInfo->m_pwZoom				= pwZoom;
		m_ChannelInfo->m_byAlarmIn 			= byAlarmIn;
		m_ChannelInfo->m_byAlarmOut			= byAlarmOut;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::SetVideoChannel( int nChannel )
{
	if( m_ChannelInfo->GetHandle() != INVALID_HANDLE_VALUE )
	{
		_PROBENET_CONNECTION_SETCHANNEL( m_ChannelInfo->GetHandle(), nChannel );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::SetMotionDetectionMode( int nChannel, int nMode )
{
	m_ChannelInfo->SetMotionDetectionMode( nMode );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::AudioSpeakerOn( BOOL bFlag )
{
	m_ChannelInfo->AudioSpeakerOn( bFlag );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::SetPTZSpeed( WORD wSpeed )
{
	m_ChannelInfo->SetPTZSpeed( wSpeed );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::SetPTZMove( int nPan, int nTilt, double nZoom )
{
	m_ChannelInfo->SetPTZMove( nPan, nTilt, nZoom );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::GetPTZCoordinates()
{
	m_ChannelInfo->GetPTZCoordinates();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CLiveObject::SetEncoderSetupInfo( int nChannel, ENCODE_SETUP_INFO *lpData )
{
	return m_ChannelInfo->SetEncoderSetupInfo( lpData );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CLiveObject::GetEncoderSetupInfo( int nChannel, ENCODE_SETUP_INFO *lpData, BOOL bRefreshData )
{
	return m_ChannelInfo->GetEncoderSetupInfo( nChannel, lpData, bRefreshData );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::GetAlarmInOutStatus()
{
	m_ChannelInfo->GetAlarmInOutStatus();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::SetOutput( int nChannel, BOOL bOn, int nOutput )
{
	m_ChannelInfo->SetOutput( bOn, nOutput );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonLeftUp( int nChannel )
{
	m_ChannelInfo->ButtonLeftUp();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonUp( int nChannel )
{
	m_ChannelInfo->ButtonUp();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonRightup( int nChannel )
{
	m_ChannelInfo->ButtonRightup();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonLeft( int nChannel )
{
	m_ChannelInfo->ButtonLeft();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonRight( int nChannel )
{
	m_ChannelInfo->ButtonRight();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonLeftdown( int nChannel )
{
	m_ChannelInfo->ButtonLeftdown();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonDown( int nChannel )
{
	m_ChannelInfo->ButtonDown();	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonRightdown( int nChannel )
{
	m_ChannelInfo->ButtonRightdown();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonStop( int nChannel )
{
	m_ChannelInfo->ButtonStop();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonZoomIn( int nChannel )
{
	m_ChannelInfo->ButtonZoomIn();	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ButtonZoomOut( int nChannel )
{
	m_ChannelInfo->ButtonZoomOut();	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ConnectVideo( BOOL bConnect )
{
	m_ChannelInfo->ConnectVideo( bConnect );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ConnectSpeaker( BOOL bConnect )
{
	m_ChannelInfo->ConnectSpeaker( bConnect );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ConnectMic( BOOL bConnect )
{
	m_ChannelInfo->ConnectMic( bConnect );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CLiveObject::ShowMotionArea(BOOL bSHow)
{
	m_ChannelInfo->m_Render->ShowMotionArea( bSHow);
}
void CLiveObject::SelectAllMotionArea()
{
	BYTE MotionArea[72];
	memset(MotionArea, 0xFF, sizeof(MotionArea));
	m_ChannelInfo->m_Render->SetMotionInfo(MotionArea,  sizeof(MotionArea));
}
void CLiveObject::ClearMotionArea()
{
	BYTE MotionArea[72];
	memset(MotionArea, 0, sizeof(MotionArea));
	m_ChannelInfo->m_Render->SetMotionInfo(MotionArea,  sizeof(MotionArea));
}
void CLiveObject::SaveMotionArea()
{
	m_ChannelInfo->SaveMotionArea();
}
void CLiveObject::SaveMotionSensitivity(int nValue)
{
	m_ChannelInfo->SaveMotionSensitivity(nValue);
}
int  CLiveObject::GetMotionSensitivity()
{
	int nValue = 1;
	nValue = m_ChannelInfo->GetMotionSensitivity();
	return nValue;
}