/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// PTZButton.cpp: implementation of the CPTZButton class.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ProbeDemo.h"
#include "PTZButton.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CPTZButton, CButton)
//{{AFX_MSG_MAP(CTestDlg)
ON_WM_LBUTTONDOWN()
ON_WM_LBUTTONUP()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Construction/Destruction
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CPTZButton::CPTZButton()
{
	m_LiveCamera	= NULL;
}

CPTZButton::~CPTZButton()
{

}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CPTZButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	SetCapture();

//	TRACE( "%s\n", m_szButtonName );

	if( !strcmp( m_szButtonName, PTZ_NAME_LEFT_UP ))
	{
		m_LiveCamera->ButtonLeftUp(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_UP ))
	{
		m_LiveCamera->ButtonUp(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_RIGHT_UP ))
	{
		m_LiveCamera->ButtonRightup(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_LEFT ))
	{
		m_LiveCamera->ButtonLeft(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_RIGHT ))
	{
		m_LiveCamera->ButtonRight(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_LEFT_DOWN ))
	{
		m_LiveCamera->ButtonLeftdown(0);	
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_DOWN ))
	{
		m_LiveCamera->ButtonDown(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_RIGHT_DOWN ))
	{
		m_LiveCamera->ButtonRightdown(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_ZOOMIN ))
	{
		m_LiveCamera->ButtonZoomIn(0);
	}
	else if( !strcmp( m_szButtonName, PTZ_NAME_ZOOMOUT ))
	{
		m_LiveCamera->ButtonZoomOut(0);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CPTZButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	ReleaseCapture();

	m_LiveCamera->ButtonStop(0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CPTZButton::Init( char *szButtonName, void *pLiveDemo )
{
	wsprintf( m_szButtonName, szButtonName );
	m_LiveCamera = (CLiveObject *)pLiveDemo;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
