/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// PTZButton.h: interface for the CPTZButton class.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PTZBUTTON_H__BDC488A0_A61F_4FE1_8190_57F891B0AC63__INCLUDED_)
#define AFX_PTZBUTTON_H__BDC488A0_A61F_4FE1_8190_57F891B0AC63__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Definition
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define MAX_BUTTON_COUNT	9

#define PTZ_INDEX_LEFT_UP		0
#define PTZ_INDEX_UP			1
#define PTZ_INDEX_RIGHT_UP		2
#define PTZ_INDEX_LEFT			3
#define PTZ_INDEX_STOP			4
#define PTZ_INDEX_RIGHT			5
#define PTZ_INDEX_LEFT_DOWN		6
#define PTZ_INDEX_DOWN			7
#define PTZ_INDEX_RIGHT_DOWN	8

#define PTZ_NAME_LEFT_UP		"LeftUp"
#define PTZ_NAME_UP				"Up"
#define PTZ_NAME_RIGHT_UP		"RightUp"
#define PTZ_NAME_LEFT			"Left"
#define PTZ_NAME_RIGHT			"Right"
#define PTZ_NAME_LEFT_DOWN		"LeftDown"
#define PTZ_NAME_DOWN			"Down"
#define PTZ_NAME_RIGHT_DOWN		"RightDown"
#define PTZ_NAME_ZOOMIN			"ZoomIn"
#define PTZ_NAME_ZOOMOUT		"ZoomOut"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "LiveDemo.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CPTZButton : public CButton
{
private:
	char			m_szButtonName[MAX_PATH];

	//..................................................

public:
	CPTZButton();
	virtual ~CPTZButton();
	CLiveObject		*m_LiveCamera;

	//..................................................

	void Init( char *szButtonName, void *pLiveDemo );

	//..................................................

protected:
	HICON m_hIcon;
	
	//..................................................
	// Generated message map functions
	//{{AFX_MSG(CPTZButton)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_PTZBUTTON_H__BDC488A0_A61F_4FE1_8190_57F891B0AC63__INCLUDED_)
