/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ProbeDemoDlg.cpp : implementation file
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ProbeDemo.h"
#include "ProbeDemoDlg.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CProbeDemoDlg dialog

CProbeDemoDlg::CProbeDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProbeDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProbeDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_LiveCamera = new CLiveObject();
	
	m_VideoSetupDlg		= NULL;
	m_EncoderSetupDlg	= NULL;
	
	memset( &m_RcvVideData, 0, sizeof( VIDEO_DATA_PACK ) );
	
	m_hDrawDib	= DrawDibOpen();
	
	m_btnPTZleftup.Init( PTZ_NAME_LEFT_UP, m_LiveCamera );
	m_btnPTZup.Init( PTZ_NAME_UP, m_LiveCamera );
	m_btnPTZrightup.Init( PTZ_NAME_RIGHT_UP, m_LiveCamera );
	m_btnPTZleft.Init( PTZ_NAME_LEFT, m_LiveCamera );
	m_btnPTZright.Init( PTZ_NAME_RIGHT, m_LiveCamera );
	m_btnPTZleftdown.Init( PTZ_NAME_LEFT_DOWN, m_LiveCamera );
	m_btnPTZdown.Init( PTZ_NAME_DOWN, m_LiveCamera );
	m_btnPTZrightdown.Init( PTZ_NAME_RIGHT_DOWN, m_LiveCamera );
	m_btnPTZZoomIn.Init( PTZ_NAME_ZOOMIN, m_LiveCamera );
	m_btnPTZZoomOut.Init( PTZ_NAME_ZOOMOUT, m_LiveCamera );

	m_nCurChannel		= CH_VIDEO1;
	m_nCurOutputNum		= OUTPUT1;

	m_wPan				= 0;
	m_wTilt				= 0;
	m_wZoom				= 0;

	m_byAlarmIn			= 0;
	m_byAlarmOut		= 0;
}

CProbeDemoDlg::~CProbeDemoDlg()
{

}

void CProbeDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProbeDemoDlg)
	DDX_Control(pDX, IDC_SLIDER_SEN, m_sliderSensitivity);
	DDX_Control(pDX, IDC_BUTTON_ZOOMOUT, m_btnPTZZoomOut);
	DDX_Control(pDX, IDC_BUTTON_ZOOMIN, m_btnPTZZoomIn);
	DDX_Control(pDX, IDC_BUTTON_DOWN, m_btnPTZdown);
	DDX_Control(pDX, IDC_BUTTON_UP, m_btnPTZup);
	DDX_Control(pDX, IDC_BUTTON_RIGHTUP, m_btnPTZrightup);
	DDX_Control(pDX, IDC_BUTTON_RIGHTDOWN, m_btnPTZrightdown);
	DDX_Control(pDX, IDC_BUTTON_RIGHT, m_btnPTZright);
	DDX_Control(pDX, IDC_BUTTON_LEFTUP, m_btnPTZleftup);
	DDX_Control(pDX, IDC_BUTTON_LEFTDOWN, m_btnPTZleftdown);
	DDX_Control(pDX, IDC_BUTTON_LEFT, m_btnPTZleft);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProbeDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CProbeDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, OnButtonDisconnect)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_CBN_SELCHANGE(IDC_COMBO_CHANNEL, OnSelchangeComboChannel)
	ON_CBN_SELCHANGE(IDC_COMBO_MOTION_MODE, OnSelchangeComboMotionMode)
	ON_BN_CLICKED(IDC_BUTTON_VIDEO_SETUP, OnButtonVideoSetup)
	ON_BN_CLICKED(IDC_BUTTON_ENCODER_SETUP, OnButtonEncoderSetting)
	ON_BN_CLICKED(IDC_BUTTON_SPEED_APPLY, OnButtonSpeedApply)
	ON_BN_CLICKED(IDC_BUTTON_PTZ_APPLY, OnButtonPtzApply)
	ON_BN_CLICKED(IDC_BUTTON_PTZ_GET, OnButtonPtzGet)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUT_ON, OnButtonOutputOn)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUT_OFF, OnButtonOutputOff)
	ON_BN_CLICKED(IDC_BUTTON_VIDEO_CONNECT, OnButtonVideoConnect)
	ON_BN_CLICKED(IDC_BUTTON_SPEAKER_CONNECT, OnButtonSpeakerConnect)
	ON_BN_CLICKED(IDC_BUTTON_MIC_CONNECT, OnButtonMicConnect)
	ON_BN_CLICKED(IDC_BUTTON_SPEAKER_ONOFF, OnButtonSpeakerOnoff)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_CBN_SELCHANGE(IDC_COMBO_RELAY_OUT_INDEX, OnSelchangeComboRelayOutIndex)
	ON_BN_CLICKED(IDC_BUTTON_ALARM_INOUT_STATUS, OnButtonAlarmInoutStatus)
	ON_BN_CLICKED(IDC_CHECK_MOTION, OnCheckMotion)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_MOT, OnButtonClearMot)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_MOT, OnButtonSaveMot)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_SEN, OnButtonSaveSen)
	ON_BN_CLICKED(IDC_BUTTON_ZOOMIN, OnButtonZoomin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CProbeDemoDlg message handlers

BOOL CProbeDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	GetDlgItem(IDC_EDIT_IP)->SetWindowText( CONNECT_PROBE_IP );
	GetDlgItem(IDC_EDIT_PORT)->SetWindowText( CONNECT_CONTROL_PORT );
	GetDlgItem(IDC_EDIT_PORT2)->SetWindowText( CONNECT_VIDEO_PORT );
	GetDlgItem(IDC_EDIT_PORT3)->SetWindowText( CONNECT_AUDIO_TX_PORT );
	GetDlgItem(IDC_EDIT_PORT4)->SetWindowText( CONNECT_AUDIO_RX_PORT );
	GetDlgItem(IDC_EDIT_ID)->SetWindowText( CONNECT_ID );
	GetDlgItem(IDC_EDIT_PASS)->SetWindowText( CONNECT_PASSWORD );

	((CButton *)GetDlgItem( IDC_BUTTON_CONNECT ))->EnableWindow( TRUE );
	((CButton *)GetDlgItem( IDC_BUTTON_DISCONNECT ))->EnableWindow( FALSE );

	//..................................................

	((CComboBox *)GetDlgItem(IDC_COMBO_MOTION_MODE))->SetCurSel(0);	// WebViewer   ġ   . (   )
	m_LiveCamera->SetMotionDetectionMode( 0, 1 );

	//..................................................

	((CButton *)GetDlgItem( IDC_BUTTON_VIDEO_SETUP ))->EnableWindow( FALSE );
	((CButton *)GetDlgItem( IDC_BUTTON_ENCODER_SETUP ))->EnableWindow( FALSE );
	((CComboBox *)GetDlgItem(IDC_COMBO_RELAY_OUT_INDEX))->SetCurSel(0);
	((CButton *)GetDlgItem( IDC_BUTTON_OUTPUT_ON ))->EnableWindow( FALSE );
	((CButton *)GetDlgItem( IDC_BUTTON_OUTPUT_OFF ))->EnableWindow( FALSE );
	
	CRect rect;
	GetDlgItem(IDC_SCREEN)->GetClientRect( &rect );
	m_LiveCamera->SetClientScreen( m_nCurChannel, GetDlgItem(IDC_SCREEN)->GetSafeHwnd(), rect.left, rect.top, rect.Width(), rect.Height() );
	m_LiveCamera->SetConnectStream( m_nCurChannel, &m_RcvVideData, &m_IsDecodingSuccess, &m_wPan, &m_wTilt, &m_wZoom, &m_byAlarmIn, &m_byAlarmOut );
	((CComboBox *)GetDlgItem(IDC_COMBO_CHANNEL))->SetCurSel(m_nCurChannel);
	
	m_VideoSetupDlg= new CVideoSetupDlg(this);
	m_VideoSetupDlg->Create( CVideoSetupDlg::IDD );
	m_VideoSetupDlg->ShowWindow( SW_HIDE );

	m_EncoderSetupDlg= new CEncoderSetupDlg(this);
	m_EncoderSetupDlg->Create( CEncoderSetupDlg::IDD );
	m_EncoderSetupDlg->ShowWindow( SW_HIDE );

	((CButton *)GetDlgItem(IDC_BUTTON_SPEAKER_ONOFF))->EnableWindow( FALSE );

	m_sliderSensitivity.SetRange(0,2,TRUE); // 6, 5, 4
	m_sliderSensitivity.SetPos(1);

	SetTimer( TIMER_CHECK_RCV, TIME_CHECK_RCV, NULL );
	//SetTimer( TIMER_DRAW_RENDER, TIME_DRAW_RENDER, NULL );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CProbeDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CProbeDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProbeDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonConnect() 
{
	char szAddr[255];
	char szControlPort[255];
	char szVideoPort[255];
	char szAudioTPort[255];
	char szAudioRPort[255];
	char szUserId[255];
	char szPasswd[255];

	GetDlgItem(IDC_EDIT_IP)->GetWindowText(szAddr, sizeof(szAddr));
	GetDlgItem(IDC_EDIT_PORT)->GetWindowText(szControlPort, sizeof(szControlPort));
	GetDlgItem(IDC_EDIT_PORT2)->GetWindowText(szVideoPort, sizeof(szVideoPort));
	GetDlgItem(IDC_EDIT_PORT3)->GetWindowText(szAudioTPort, sizeof(szAudioTPort));
	GetDlgItem(IDC_EDIT_PORT4)->GetWindowText(szAudioRPort, sizeof(szAudioRPort));
	GetDlgItem(IDC_EDIT_ID)->GetWindowText(szUserId, sizeof(szUserId));
	GetDlgItem(IDC_EDIT_PASS)->GetWindowText(szPasswd, sizeof(szPasswd));

	m_LiveCamera->OnConnect( szAddr, szControlPort, szVideoPort, szAudioTPort, szAudioRPort, szUserId, szPasswd );
	
	m_VideoSetupDlg->SetLoginInfo( szAddr, szUserId, szPasswd );
	((CButton *)GetDlgItem( IDC_BUTTON_VIDEO_SETUP ))->EnableWindow( TRUE );
	((CButton *)GetDlgItem( IDC_BUTTON_ENCODER_SETUP ))->EnableWindow( TRUE );

	((CButton *)GetDlgItem( IDC_BUTTON_CONNECT ))->EnableWindow( FALSE );
	((CButton *)GetDlgItem( IDC_BUTTON_DISCONNECT ))->EnableWindow( TRUE );
	((CButton *)GetDlgItem( IDC_BUTTON_OUTPUT_ON ))->EnableWindow( TRUE );
	((CButton *)GetDlgItem( IDC_BUTTON_OUTPUT_OFF ))->EnableWindow( TRUE );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonDisconnect() 
{
	// TODO: Add your control notification handler code here
	m_LiveCamera->OnDisConnect();
		
	((CButton *)GetDlgItem( IDC_BUTTON_VIDEO_SETUP ))->EnableWindow( FALSE );
	((CButton *)GetDlgItem( IDC_BUTTON_ENCODER_SETUP ))->EnableWindow( FALSE );

	((CButton *)GetDlgItem( IDC_BUTTON_CONNECT ))->EnableWindow( TRUE );
	((CButton *)GetDlgItem( IDC_BUTTON_DISCONNECT ))->EnableWindow( FALSE );

	((CButton *)GetDlgItem( IDC_BUTTON_OUTPUT_ON ))->EnableWindow( FALSE );
	((CButton *)GetDlgItem( IDC_BUTTON_OUTPUT_OFF ))->EnableWindow( FALSE );

	((CButton *)GetDlgItem( IDC_BUTTON_VIDEO_CONNECT ))->SetWindowText( "Connect" );
	((CButton *)GetDlgItem( IDC_BUTTON_SPEAKER_CONNECT ))->SetWindowText( "Connect" );
	((CButton *)GetDlgItem( IDC_BUTTON_MIC_CONNECT ))->SetWindowText( "Connect" );

	((CButton *)GetDlgItem(IDC_BUTTON_SPEAKER_ONOFF))->EnableWindow( FALSE );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
    // It doesn't need to cycle for each channel, m_LiveCamera->OnDestroy release them all. And m_LiveCamera must be deleted
	if ( m_LiveCamera )
    {
        m_LiveCamera->OnDestroy();
	    delete m_LiveCamera ;
    }

	if(m_hDrawDib)
	{
		DrawDibClose(m_hDrawDib);
		m_hDrawDib = NULL;
	}

	if( m_VideoSetupDlg )
	{
		delete m_VideoSetupDlg;
		m_VideoSetupDlg = NULL;
	}

	if( m_EncoderSetupDlg )
	{
		delete m_EncoderSetupDlg;
		m_EncoderSetupDlg = NULL;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if( nIDEvent == TIMER_CHECK_RCV )
	{
		DisplayVideoInfo();
		CString strTemp;
	
		switch( m_RcvVideData.m_isCompMode )
		{
		case 0:	strTemp.Format( "MJPEG(PENTA)" );	break;
		case 1:	strTemp.Format( "MPEG4(PENTA)" );	break;
		case 2:	strTemp.Format( "MPEG4(DM365)" );	break;
		case 3:	strTemp.Format( "H264(DM365)" );	break;
		case 4:	strTemp.Format( "MJPEG(DM365)" );	break;
		default: strTemp.Format( "No Type" );	break;
		}

		if( !strTemp.Compare( "No Type" ) )
		{
			GetDlgItem(IDC_EDIT_FRAME_CODECTYPE)->SetWindowText( strTemp );
			GetDlgItem(IDC_EDIT_VIDEO_TYPE)->SetWindowText( "No Type" );
			GetDlgItem(IDC_EDIT_RESOLUTION)->SetWindowText( "0 X 0" );
			GetDlgItem(IDC_EDIT_FRAME_TYPE)->SetWindowText( "No Type" );
			GetDlgItem(IDC_EDIT_FRAME_CHANNEL)->SetWindowText( "No Channel" );
			GetDlgItem(IDC_EDIT_FRAME_NUMBER)->SetWindowText( "0" );
			GetDlgItem(IDC_EDIT_FRAME_SIZE)->SetWindowText( "0" );
			GetDlgItem(IDC_EDIT_DECODING)->SetWindowText( "None" );
		}
		else
		{
			GetDlgItem(IDC_EDIT_FRAME_CODECTYPE)->SetWindowText( strTemp );

			strTemp.Format( "%s", ( (m_RcvVideData.m_nVideo_type-1) ? "PAL" : "NTSC" ));
			GetDlgItem(IDC_EDIT_VIDEO_TYPE)->SetWindowText( strTemp );

			switch( m_RcvVideData.m_nResolution_Id ) 
			{
			case 8: strTemp.Format( "1920 X 1080" );break;
			case 9: strTemp.Format( "1280 X 720" );	break;
			case 10: strTemp.Format( "720 X 576" );	break;
			case 11: strTemp.Format( "720 X 480" );	break;
			case 12: strTemp.Format( "720 X 288" );	break;
			case 13: strTemp.Format( "720 X 240" );	break;
			case 14: strTemp.Format( "704 X 576" );	break;
			case 15: strTemp.Format( "704 X 480" );	break;
			case 16: strTemp.Format( "704 X 288" );	break;
			case 17: strTemp.Format( "704 X 240" );	break;
			case 18: strTemp.Format( "640 X 480" );	break;
			case 19: strTemp.Format( "352 X 288" );	break;
			case 20: strTemp.Format( "352 X 240" );	break;
			case 21: strTemp.Format( "320 X 240" );	break;
			case 22: strTemp.Format( "176 X 144" );	break;
			case 23: strTemp.Format( "176 X 128" );	break;
			case 24: strTemp.Format( "160 X 120" );	break;
			default: strTemp.Format( "0 X 0" );	break;
			}
			GetDlgItem(IDC_EDIT_RESOLUTION)->SetWindowText( strTemp );

			strTemp.Format( "%s", ( (m_RcvVideData.m_nFrame_type) ? "P Frame" : "I Frame" ));
			GetDlgItem(IDC_EDIT_FRAME_TYPE)->SetWindowText( strTemp );

			strTemp.Format( "%d", m_RcvVideData.m_nChannelInfo+1 );
			GetDlgItem(IDC_EDIT_FRAME_CHANNEL)->SetWindowText( strTemp );

			strTemp.Format( "%ld", m_RcvVideData.m_nFrame_Num);
			GetDlgItem(IDC_EDIT_FRAME_NUMBER)->SetWindowText( strTemp );

			strTemp.Format( "%ld", m_RcvVideData.m_nFrame_Size);
			GetDlgItem(IDC_EDIT_FRAME_SIZE)->SetWindowText( strTemp );

			strTemp.Format( "%s", (m_IsDecodingSuccess ? "Success" : "Fail") );
			GetDlgItem(IDC_EDIT_DECODING)->SetWindowText( strTemp );
		}

		strTemp.Format( "%s", ( (m_LiveCamera->GetControlConnection()) ? "Connected" : "Disconnect" ));
		GetDlgItem(IDC_EDIT_EVENT_CONTROL_STATUS)->SetWindowText( strTemp );
		if( strTemp == "Disconnect" )
		{
			(GetDlgItem(IDC_BUTTON_VIDEO_CONNECT))->EnableWindow( FALSE );
			(GetDlgItem(IDC_BUTTON_SPEAKER_CONNECT))->EnableWindow( FALSE );
			(GetDlgItem(IDC_BUTTON_MIC_CONNECT))->EnableWindow( FALSE );
		}
		else
		{
			(GetDlgItem(IDC_BUTTON_VIDEO_CONNECT))->EnableWindow( TRUE );
			(GetDlgItem(IDC_BUTTON_SPEAKER_CONNECT))->EnableWindow( TRUE );
			(GetDlgItem(IDC_BUTTON_MIC_CONNECT))->EnableWindow( TRUE );
		}

		switch( m_LiveCamera->GetControlStatus() )
		{
		case STATUS_CONNECTED: strTemp.Format( "Connection" ); break;
		case STATUS_LOGON_FAIL: strTemp.Format( "Logon Fail" ); break;
		case STATUS_LOGON: strTemp.Format( "Logon" ); break;
		case STATUS_LOGOFF: strTemp.Format( "LogOff" ); break;
		default:
			strTemp.Format( "None" ); break;
		}
		GetDlgItem(IDC_EDIT_EVENT_CONTROL_LOGON)->SetWindowText( strTemp );
		
		strTemp.Format( "%s", ( (m_LiveCamera->GetVideoConnection()) ? "Connected" : "Disconnect" ));
		GetDlgItem(IDC_EDIT_EVENT_VIDEO_STATUS)->SetWindowText( strTemp );
		switch( m_LiveCamera->GetVideoStatus() )
		{
		case STATUS_CONNECTED: strTemp.Format( "Connection" ); break;
		case STATUS_LOGON_FAIL: strTemp.Format( "Logon Fail" ); break;
		case STATUS_LOGON: strTemp.Format( "Logon" ); break;
		case STATUS_LOGOFF: strTemp.Format( "LogOff" ); break;
		default:
			strTemp.Format( "None" ); break;
		}
		GetDlgItem(IDC_EDIT_EVENT_VIDEO_LOGON)->SetWindowText( strTemp );

		
		strTemp.Format( "%s", ( (m_LiveCamera->GetAudioSpeakerConnection()) ? "Connected" : "Disconnect" ));
		GetDlgItem(IDC_EDIT_AUDIO_SPEAKER_STATUS)->SetWindowText( strTemp );
		switch( m_LiveCamera->GetAudioSpeakerStatus() )
		{
		case STATUS_CONNECTED: strTemp.Format( "Connection" ); break;
		case STATUS_LOGON_FAIL: strTemp.Format( "Logon Fail" ); break;
		case STATUS_LOGON: strTemp.Format( "Logon" ); break;
		case STATUS_LOGOFF: strTemp.Format( "LogOff" ); break;
		default:
			strTemp.Format( "None" ); break;
		}
		GetDlgItem(IDC_EDIT_AUDIO_SPEAKER_LOGON)->SetWindowText( strTemp );

		strTemp.Format( "%s", ( (m_LiveCamera->GetAudioMicConnection()) ? "Connected" : "Disconnect" ));
		GetDlgItem(IDC_EDIT_AUDIO_MIC_STATUS)->SetWindowText( strTemp );
		switch( m_LiveCamera->GetAudioMicStatus() )
		{
		case STATUS_CONNECTED: strTemp.Format( "Connection" ); break;
		case STATUS_LOGON_FAIL: strTemp.Format( "Logon Fail" ); break;
		case STATUS_LOGON: strTemp.Format( "Logon" ); break;
		case STATUS_LOGOFF: strTemp.Format( "LogOff" ); break;
		default:
			strTemp.Format( "None" ); break;
		}
		GetDlgItem(IDC_EDIT_AUDIO_MIC_LOGON)->SetWindowText( strTemp );

		strTemp.Format( "%s", ( (m_LiveCamera->GetMotionEvent()) ? "Detected" : "None" ));
		GetDlgItem(IDC_EDIT_EVENT_MOTION)->SetWindowText( strTemp );
		
		strTemp.Format( "%s", ( (m_LiveCamera->GetAlarmInput1Status()) ? "Detected" : "None" ));
		GetDlgItem(IDC_EDIT_EVENT_ALARM1)->SetWindowText( strTemp );

		strTemp.Format( "%s", ( (m_LiveCamera->GetAlarmINput2Status()) ? "Detected" : "None" ));
		GetDlgItem(IDC_EDIT_EVENT_ALARM2)->SetWindowText( strTemp );

		strTemp.Format( "%d", (m_wPan/100) );
		GetDlgItem(IDC_EDIT_PAN_GET)->SetWindowText(strTemp);
		strTemp.Format( "%d", (m_wTilt/100) );
		GetDlgItem(IDC_EDIT_TILT_GET)->SetWindowText(strTemp);
		strTemp.Format( "%d", m_wZoom );
		GetDlgItem(IDC_EDIT_ZOOM_GET)->SetWindowText(strTemp);
		strTemp.Format( "%d/%d", m_byAlarmIn, m_byAlarmOut );
		GetDlgItem(IDC_EDIT_ALARM_INOUT_STATUS)->SetWindowText(strTemp);

		/*	
		struct tm *tDataTime;
		tDataTime=gmtime((long*)&m_RcvVideData.m_nSystemTime);
		strTemp.Format( "%d-%d-%d %d:%d:%d", 
			tDataTime->tm_year+1900, tDataTime->tm_mon+1, tDataTime->tm_mday, tDataTime->tm_hour, tDataTime->tm_min, tDataTime->tm_sec );
		GetDlgItem(IDC_EDIT_SERVER_TIME)->SetWindowText( strTemp );
		*/

		m_sliderSensitivity.SetPos(m_LiveCamera->GetMotionSensitivity());

		UpdateData( FALSE );
		
		
	}
	else if(nIDEvent ==TIMER_DRAW_RENDER)
	{

	}

	CDialog::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnSelchangeComboChannel() 
{
	// TODO: Add your control notification handler code here
	m_nCurChannel = ((CComboBox *)GetDlgItem(IDC_COMBO_CHANNEL))->GetCurSel();

	m_LiveCamera->SetVideoChannel( m_nCurChannel );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnSelchangeComboMotionMode() 
{
	// TODO: Add your control notification handler code here
	if( ((CComboBox *)GetDlgItem(IDC_COMBO_MOTION_MODE))->GetCurSel() == 0 )	// Motion Detection Off
		m_LiveCamera->SetMotionDetectionMode( 0, 0);
	else if( ((CComboBox *)GetDlgItem(IDC_COMBO_MOTION_MODE))->GetCurSel() == 1 )	// Motion Detection On
		m_LiveCamera->SetMotionDetectionMode( 0, 1 );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnSelchangeComboRelayOutIndex() 
{
	// TODO: Add your control notification handler code here
	m_nCurOutputNum = ((CComboBox *)GetDlgItem(IDC_COMBO_RELAY_OUT_INDEX))->GetCurSel();	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonVideoSetup() 
{
	// TODO: Add your control notification handler code here
	m_VideoSetupDlg->Init();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonEncoderSetting() 
{
	// TODO: Add your control notification handler code here
	m_EncoderSetupDlg->Init( m_LiveCamera );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonSpeedApply() 
{
	// TODO: Add your control notification handler code here
	char		szPTZSpeed[255];
	GetDlgItem(IDC_EDIT_PTZ_SPEED)->GetWindowText(szPTZSpeed, sizeof(szPTZSpeed));
	m_LiveCamera->SetPTZSpeed( (WORD)atoi(szPTZSpeed) );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonPtzApply() 
{
	// TODO: Add your control notification handler code here
	char		szPan[255];
	char		szTilt[255];
	char		szZoom[255];
	GetDlgItem(IDC_EDIT_PAN_SET)->GetWindowText(szPan, sizeof(szPan));
	GetDlgItem(IDC_EDIT_TILT_SET)->GetWindowText(szTilt, sizeof(szTilt));
	GetDlgItem(IDC_EDIT_ZOOM_SET)->GetWindowText(szZoom, sizeof(szZoom));

	m_LiveCamera->SetPTZMove( atoi(szPan)*100, atoi(szTilt)*100, (double)atoi(szZoom) );
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonPtzGet() 
{
	// TODO: Add your control notification handler code here
	m_LiveCamera->GetPTZCoordinates();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonOutputOn() 
{
	m_LiveCamera->SetOutput( m_nCurChannel, TRUE, m_nCurOutputNum ) ;	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonOutputOff() 
{
	m_LiveCamera->SetOutput( m_nCurChannel, FALSE, m_nCurOutputNum ) ;	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonVideoConnect() 
{
	// TODO: Add your control notification handler code here
	char szConnection[255];

	GetDlgItem(IDC_BUTTON_VIDEO_CONNECT)->GetWindowText(szConnection, sizeof(szConnection));
	if( lstrcmp( szConnection, "Connect" ) == 0 )
	{
		GetDlgItem(IDC_BUTTON_VIDEO_CONNECT)->SetWindowText( "Disconnect" );
		m_LiveCamera->ConnectVideo( TRUE );
	}
	else
	{
		GetDlgItem(IDC_BUTTON_VIDEO_CONNECT)->SetWindowText( "Connect" );
		m_LiveCamera->ConnectVideo( FALSE );
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonSpeakerConnect() 
{
	// TODO: Add your control notification handler code here
	char szConnection[255];

	GetDlgItem(IDC_BUTTON_SPEAKER_CONNECT)->GetWindowText(szConnection, sizeof(szConnection));
	if( lstrcmp( szConnection, "Connect" ) == 0 )
	{
		GetDlgItem(IDC_BUTTON_SPEAKER_CONNECT)->SetWindowText( "Disconnect" );
		m_LiveCamera->ConnectSpeaker( TRUE );
		((CButton *)GetDlgItem(IDC_BUTTON_SPEAKER_ONOFF))->EnableWindow( TRUE );
	}
	else
	{
		GetDlgItem(IDC_BUTTON_SPEAKER_CONNECT)->SetWindowText( "Connect" );
		m_LiveCamera->ConnectSpeaker( FALSE );
		((CButton *)GetDlgItem(IDC_BUTTON_SPEAKER_ONOFF))->EnableWindow( FALSE );
	}	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonMicConnect() 
{
	// TODO: Add your control notification handler code here
	char szConnection[255];

	GetDlgItem(IDC_BUTTON_MIC_CONNECT)->GetWindowText(szConnection, sizeof(szConnection));
	if( lstrcmp( szConnection, "Connect" ) == 0 )
	{
		GetDlgItem(IDC_BUTTON_MIC_CONNECT)->SetWindowText( "Disconnect" );
		m_LiveCamera->ConnectMic( TRUE );
	}
	else
	{
		GetDlgItem(IDC_BUTTON_MIC_CONNECT)->SetWindowText( "Connect" );
		m_LiveCamera->ConnectMic( FALSE );
	}	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonSpeakerOnoff() 
{
	// TODO: Add your control notification handler code here
	char szOnOff[255];

	GetDlgItem(IDC_BUTTON_SPEAKER_ONOFF)->GetWindowText(szOnOff, sizeof(szOnOff));
	if( lstrcmp( szOnOff, "Speaker On" ) == 0 )
	{
		GetDlgItem(IDC_BUTTON_SPEAKER_ONOFF)->SetWindowText( "Speaker Off" );
		m_LiveCamera->AudioSpeakerOn( TRUE );
	}
	else
	{
		GetDlgItem(IDC_BUTTON_SPEAKER_ONOFF)->SetWindowText( "Speaker On" );
		m_LiveCamera->AudioSpeakerOn( FALSE );
	}	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonAlarmInoutStatus() 
{
	// TODO: Add your control notification handler code here
	m_LiveCamera->GetAlarmInOutStatus();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnButtonExit() 
{
	// TODO: Add your control notification handler code here
	OnButtonDisconnect();

	CDialog::OnOK();	
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::DisplayVideoInfo() 
{
	// TODO: Add your control notification handler code here
	char szStatus[255];
	GetDlgItem( IDC_EDIT_EVENT_VIDEO_STATUS )->GetWindowText(szStatus, sizeof(szStatus));

	CString strTemp;
	if( !strcmp( szStatus, "Disconnect" ) )
	{
		strTemp.Format( "None" );
		GetDlgItem(IDC_EDIT_PRODUCT_NAME)->SetWindowText( strTemp );
		GetDlgItem(IDC_EDIT_MAC_ADDRESS)->SetWindowText( strTemp );
		return;
	}
	else
	{
		CAMERA_CONFIG	stCameraInfo;
		stCameraInfo = m_LiveCamera->GetCameraConfig();
		
		if(lstrlen((char *)stCameraInfo.camera_name) > 0)
		{
			strTemp.Format( "%s", stCameraInfo.camera_name );
			GetDlgItem(IDC_EDIT_PRODUCT_NAME)->SetWindowText( strTemp );
		}

		if(lstrlen((char *)stCameraInfo.camera_macaddress) > 0)
		{
			strTemp.Format( "%s", stCameraInfo.camera_macaddress );
			GetDlgItem(IDC_EDIT_MAC_ADDRESS)->SetWindowText( strTemp );
		}

	}
	
	UpdateData( FALSE );
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CProbeDemoDlg::OnCheckMotion() 
{
	// TODO: Add your control notification handler code here
	if( ((CButton *)GetDlgItem(IDC_CHECK_MOTION))->GetCheck() )
	{
		m_LiveCamera->ShowMotionArea(TRUE);
	}
	else
	{
		m_LiveCamera->ShowMotionArea(FALSE);
	}
}

void CProbeDemoDlg::OnButtonAllMot() 
{
	// TODO: Add your control notification handler code here
	m_LiveCamera->SelectAllMotionArea();
}

void CProbeDemoDlg::OnButtonClearMot() 
{
	// TODO: Add your control notification handler code here
	m_LiveCamera->ClearMotionArea();
}

void CProbeDemoDlg::OnButtonSaveMot() 
{
	// TODO: Add your control notification handler code here
	m_LiveCamera->SaveMotionArea();
}

void CProbeDemoDlg::OnButtonSaveSen() 
{
	// TODO: Add your control notification handler code here
	int nValue = m_sliderSensitivity.GetPos();
	m_LiveCamera->SaveMotionSensitivity(nValue);	
}


void CProbeDemoDlg::OnButtonZoomin() 
{
	// TODO: Add your control notification handler code here
	
}
