// Texture.cpp: implementation of the CTexture class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ProbeDemo.h"
#include "Texture.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTexture::CTexture()
{
	m_d3dformat = D3DFMT_A8R8G8B8;
	m_TextureWidth	= 0;
	m_TextureHeight	= 0;
	m_nWidth	= 0;
	m_nHeight	= 0;
	m_WindowWidth = 0;
	m_WindowHeight = 0;
	m_pTexture	= NULL;
	m_VertexBuffer = NULL;
	m_pDevice	= NULL;
}

CTexture::~CTexture(void)
{
	Clear();
}
void CTexture::Draw(long x, long y, long w, long h, 
							float tx, float ty, float tw, float th,
							D3DCOLOR color)
{
	m_pDevice->SetTexture(0, m_pTexture); 

	// ڵ Ǹ  ؽ۸  ʰ,
	// ׳  ü ߽ϴ.
	// ȿ  ƴ϶ մϴ.
	// ٽѹ 帮,    D3D
	//  2D  ִ Դϴ.
	static CUSTOMVERTEX	v[4];
	float rhw=1.0f;//1.0f/(1.0f*990.0f+10.0f);

	long i;
	for( i=0; i<4; i++ )
	{
		v[i].position.z = 1.0f;
		v[i].rhw		= rhw;
		v[i].color 		= color;
	}
	
	// 0.5   ȵ˴ϴ.
	// Ȼְ ȸ/Ȯ//͸ پ  غø
	// ° 巯° Ǽ ֽϴ.	
	v[0].position.x = x-0.5f;
	v[0].position.y = y-0.5f;
	v[1].position.x = w-0.5f;
	v[1].position.y = y-0.5f;
	v[2].position.x = w-0.5f;
	v[2].position.y = h-0.5f;
	v[3].position.x = x-0.5f;
	v[3].position.y = h-0.5f;

	v[0].tu0 = (float)tx;
	v[0].tv0 = (float)ty;
	v[1].tu0 = v[0].tu0 + tw;
	v[1].tv0 = v[0].tv0;
	v[2].tu0 = v[0].tu0 + tw;
	v[2].tv0 = v[0].tv0 + th;
	v[3].tu0 = v[0].tu0;
	v[3].tv0 = v[0].tv0 + th;

	m_pDevice->DrawPrimitiveUP(D3DPT_TRIANGLEFAN , 2, v, sizeof(CUSTOMVERTEX) );
	//m_pDevice->SetStreamSource(0, m_VertexBuffer, sizeof(CUSTOMVERTEX)); 
	//m_pDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP , 0, 2);
}
int CTexture::Blt(BYTE *pVideoBuffer, int nWidth, int nHeight, int nPitch)
{
	BYTE  *pTextureBuffer;
    long  TexturePitch;
 
	if( !m_pTexture )
		return 0;

    //Lock the Texture buffer for writing
    D3DLOCKED_RECT LockedRect;
    if (FAILED(m_pTexture->LockRect(0, &LockedRect, 0, 0)))
        return E_FAIL;

    
	m_nWidth	= nWidth;
	m_nHeight	= nHeight;

    // Get the texture buffer & pitch
    pTextureBuffer = static_cast<byte *>(LockedRect.pBits);
    TexturePitch = LockedRect.Pitch;
    
    //If we've gotten this far, we are dealing with 24bit frames.
	//Walk through row by row
	//pVideoBuffer = pVideoBuffer+nPitch*(nHeight-1);
	for(long y = 0; y < nHeight; y++) 
	{
        BYTE *pVideoRowStart = pVideoBuffer;
        BYTE *pTextureRowStart = pTextureBuffer;  
		
		//walk through each pixel of the row
        for (int x = 0; x < nWidth; x++) 
		{
            pTextureBuffer[0] = pVideoBuffer[0];
            pTextureBuffer[1] = pVideoBuffer[1];
            pTextureBuffer[2] = pVideoBuffer[2];
            pTextureBuffer[3] = pVideoBuffer[3];

            pTextureBuffer += 4;
            pVideoBuffer   += 4;
        }

        //Increment to the next row
		pVideoBuffer   = pVideoRowStart   + nPitch;
        pTextureBuffer = pTextureRowStart + TexturePitch;
    }

    //unlock the texture
	if (FAILED(m_pTexture->UnlockRect(0)))
        return E_FAIL;

	/*
    D3DLOCKED_RECT LockedRect;
    if (FAILED(m_pTexture->LockRect(0, &LockedRect, 0, 0)))
        return E_FAIL;

    
	m_nWidth	= nWidth;
	m_nHeight	= nHeight;

    // Get the texture buffer & pitch
    pTextureBuffer = static_cast<byte *>(LockedRect.pBits);
    TexturePitch = LockedRect.Pitch;
    
    //If we've gotten this far, we are dealing with 24bit frames.
	//Walk through row by row
	pVideoBuffer = pVideoBuffer+nPitch*(nHeight-1);
	for(long y = 0; y < nHeight; y++) 
	{
        BYTE *pVideoRowStart = pVideoBuffer;
        BYTE *pTextureRowStart = pTextureBuffer;  
		
		//walk through each pixel of the row
        for (int x = 0; x < nWidth; x++) 
		{
            pTextureBuffer[0] = pVideoBuffer[0];
            pTextureBuffer[1] = pVideoBuffer[1];
            pTextureBuffer[2] = pVideoBuffer[2];
            pTextureBuffer[3] = 0xff;

            pTextureBuffer += 4;
            pVideoBuffer   += 3;
        }

        //Increment to the next row
		pVideoBuffer   = pVideoRowStart   - nPitch;
        pTextureBuffer = pTextureRowStart + TexturePitch;
    }

    //unlock the texture
	if (FAILED(m_pTexture->UnlockRect(0)))
        return E_FAIL;

	*/

    return S_OK;
}
/*
void Texture::Init (const char * Filename) 
{ 
        TGAFile file; 
        file.read(Filename); 
        m_Width=file.m_Width; 
        m_Height=file.m_Height; 
        m_Pitch=file.m_Pitch; 
  
        MyD3D.m_pd3dDevice->CreateTexture( file.m_Width, file.m_Height, 0, 0, 
        D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &pTexture ); 
  
        D3DLOCKED_RECT d3dlr; 
        pTexture->LockRect( 0, &d3dlr, 0, 0 ); 
        DWORD * pDst = (DWORD *)d3dlr.pBits; 
        int DPitch = d3dlr.Pitch4; 
        DWORD * pSrc = (DWORD *)file.m_PixelData; 
        int SPitch = file.m_Pitch4; 
  
        for (int i=0; i                 for (int j=0; j                         pDst[i*DPitch + j] = pSrc[i*SPitch + j];                         
  
        pTexture->UnlockRect (0); 
}
//////////////////
for (int y=0; y< Height; ++y) 
{
   for (int x=0; x< Width; ++x) 
   {
       pDst[y*DPitch + x] = pSrc[y*SPitch + x];
   }
}
///////////////////
pDst[y*Dpitch + x] = ( alpha << 24 | red << 16 | green << 8 | blue )
*/
LPDIRECT3DTEXTURE8 CTexture::GetTexture()
{
	return m_pTexture;
}
LPDIRECT3DVERTEXBUFFER8 CTexture::GetVertexBuffer()
{
	return m_VertexBuffer;
}
int CTexture::GetWindowWidth()
{
	return m_WindowWidth;
}
int CTexture::GetWindowHeight()
{
	return m_WindowHeight;
}
int CTexture::GetWidth()
{
	if(m_nWidth == 0)
	{
		return m_nWidth;
	}
	return m_WindowWidth*m_TextureWidth/m_nWidth;
}
int CTexture::GetHeight()
{
	if(m_nHeight == 0)
	{
		return m_nHeight;
	}
	return m_WindowHeight*m_TextureHeight/m_nHeight;
}
_D3DFORMAT CTexture::GetFormat()
{
	return m_d3dformat;
}

HRESULT CTexture::Init(LPDIRECT3DDEVICE8 pDevice, int nWindowWidth, int nWindowHeight, _D3DFORMAT d3dformat)
{
	m_pDevice = pDevice;

	m_WindowWidth = nWindowWidth;
	m_WindowHeight = nWindowHeight;

	m_d3dformat = d3dformat;
	//The pitch is based on an RGB24 bitmap
    //m_TexturePitch = (m_nWidth * 3 + 3) & ~(3);
	
    // Create the texture that maps to this media type
    if(FAILED(m_pDevice->CreateTexture(1920, 1080, 1, 0, 
                                d3dformat, D3DPOOL_MANAGED, &m_pTexture)))
	{
        return	E_FAIL;
	}

    //Make sure that we actually got the format we asked for
    D3DSURFACE_DESC SurfaceDescription;
    m_pTexture->GetLevelDesc(0, &SurfaceDescription);
//    if (SurfaceDescription.Format != D3DFMT_A8R8G8B8) 
//        return E_FAIL;

	m_TextureWidth  = SurfaceDescription.Width; 
	m_TextureHeight = SurfaceDescription.Height;

	m_pDevice->SetVertexShader( D3DFVF_CUSTOMVERTEX );

    // Create a 4-point vertex buffer 
    /*
	if( FAILED( pDevice->CreateVertexBuffer( 
        4*sizeof(CUSTOMVERTEX), 0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, 
        &m_VertexBuffer) ) ) 
            return E_FAIL; 

    CUSTOMVERTEX* pVertices; 
    if( FAILED( m_VertexBuffer->Lock( 0, 4*sizeof(CUSTOMVERTEX), 
        (BYTE**)&pVertices, 0 ) ) ) 
            return E_FAIL; 

    pVertices[0].position=D3DXVECTOR3( -1.0f,  1.0f, 0.5f ); 
    pVertices[0].color=0xffffffff; 
    pVertices[0].tu=0.0; 
    pVertices[0].tv=0.0; 
    pVertices[1].position=D3DXVECTOR3( 1.0f,  1.0f, 0.5f ); 
    pVertices[1].color=0xffffffff; 
    pVertices[1].tu=1.0; 
    pVertices[1].tv=0.0; 
    pVertices[2].position=D3DXVECTOR3( -1.0f,  -1.0f, 0.5f ); 
    pVertices[2].color=0xffffffff; 
    pVertices[2].tu=0.0; 
    pVertices[2].tv=1.0; 
    pVertices[3].position=D3DXVECTOR3(  1.0f,  -1.0f, 0.5f ); 
    pVertices[3].color=0xffffffff; 
    pVertices[3].tu=1.0; 
    pVertices[3].tv=1.0; 

    m_VertexBuffer->Unlock(); 
	*/

	return S_OK;
}
void   CTexture::SetVertRect(int x, int y, int w, int h, float d)
{
	/*
	float left, top, right, bottom; 
	left    = ((float)x  (float)VIEWPORT_WIDTH) * 2.0f - 1.0f; 
	right   = ((float)(x + w)  (float)VIEWPORT_WIDTH) * 2.0f - 1.0f; 
	top     = ((float)y  (float)VIEWPORT_HEIGHT) * 2.0f - 1.0f; 
	bottom  = ((float)(y + h)  (float)VIEWPORT_HEIGHT) * 2.0f - 1.0f; 

	CUSTOMVERTEX* pVertices; 
	m_VertexBuffer->Lock( 0, 4*sizeof(CUSTOMVERTEX), (BYTE**)&pVertices, 0); 

	pVertices[0].position=D3DXVECTOR3( left,  bottom, d ); 
	pVertices[1].position=D3DXVECTOR3( right,  bottom, d ); 
	pVertices[2].position=D3DXVECTOR3( left,  top, d ); 
	pVertices[3].position=D3DXVECTOR3( right,  top, d ); 

	m_VertexBuffer->Unlock(); 
	*/
}
void	CTexture::Clear()
{
	//Clean up the texture
	if (m_pTexture)
	{
		m_pTexture->Release();
		m_pTexture = NULL;
	}
	if(m_VertexBuffer)
	{
		m_VertexBuffer->Release();
		m_VertexBuffer = NULL;
	}
}
