/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// VideoCodec.cpp: implementation of the CVideoCodec class.
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include File
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ProbeDemo.h"
#include "VideoCodec.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Construction/Destruction
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CVideoCodec::CVideoCodec()
{
	m_nCodecIndex	= CODECINDEX_MJPEG;
	m_dwWidth		= 0;
	m_dwHeight		= 0;

	m_hDec = _MPCODEC_DEC_INIT( m_nCodecIndex, FALSE );
}

CVideoCodec::CVideoCodec( int nCodecIndex )
{
	m_nCodecIndex	= nCodecIndex;
	m_dwWidth		= 0;
	m_dwHeight		= 0;

//	TRACE( "VideoCodec = %d", nCodecIndex );

	m_hDec = _MPCODEC_DEC_INIT( m_nCodecIndex, FALSE );
}

CVideoCodec::~CVideoCodec()
{
	if(m_hDec)
	{
		_MPCODEC_DEC_END(m_hDec);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD CVideoCodec::GetWidth()
{
	return m_dwWidth;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD CVideoCodec::GetHeight()
{
	return m_dwHeight;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CVideoCodec::DEC_VIDEO( PBYTE pbENCBuf, PBYTE pDECYUV, DWORD dwVideoSize, int *lpnWidth, int *lpnHeight, DWORD *lpdwNumberOfChannels )
{
	BOOL bResult = FALSE;
	if(m_hDec)
	{

		DWORD dwWidth	= 0;
		DWORD dwHeight  = 0;
		
		bResult = _MPCODEC_DEC_DECODE( m_hDec, (char *)pbENCBuf, dwVideoSize, (char *)pDECYUV, &dwWidth, &dwHeight, lpdwNumberOfChannels );
		if(bResult)
		{
			//TRACE( "%d, %d\n ", dwWidth, dwHeight );

			m_dwWidth = dwWidth;
			m_dwHeight = dwHeight;
			*lpnWidth = (int)dwWidth;
			*lpnHeight = (int)dwHeight;
			bResult = TRUE;
		}
	}
	return bResult;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////