/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// VideoCodec.h: interface for the CVideoCodec class.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIDEOCODEC_H__BF120ABD_BBFA_4D13_8C3F_F3A371756E6B__INCLUDED_)
#define AFX_VIDEOCODEC_H__BF120ABD_BBFA_4D13_8C3F_F3A371756E6B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
#ifdef _MPCODEC_DLL_
	#define API_MPCODEC extern "C" __declspec(dllexport)
#else
	#define API_MPCODEC extern "C" __declspec(dllimport)
#endif

extern "C" __declspec(dllimport)   HANDLE _MPCODEC_DEC_INIT(DWORD dwCodecId, BOOL deinterlacemode=FALSE);
extern "C" __declspec(dllimport)  BOOL   _MPCODEC_DEC_DECODE(HANDLE handle, char *pInputData, DWORD dwInputBytes, char *lpOutBuf, DWORD *lpdwWidth, DWORD *lpdwHeight, DWORD *lpdwFmtType);
extern "C" __declspec(dllimport)   void   _MPCODEC_DEC_END(HANDLE handle);
*/

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Definition
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define CODECINDEX_MJPEG		8
#define CODECINDEX_MPEG4		13
#define CODECINDEX_MSMPEG4V1	15
#define CODECINDEX_MSMPEG4V2	16
#define CODECINDEX_MSMPEG4V3	17
#define CODECINDEX_WMV1			18
#define CODECINDEX_WMV2			19
#define CODECINDEX_H264			28
#define CODECINDEX_XVID			63

#define PIXELFMT_YUV422			1
#define PIXELFMT_RGB24			2

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// enum
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

enum CodecType				{ MJPEG_MD_PENTA, MPEG4_MD_PENTA, MPEG4_MD_DM365, H264_MD_DM365, MJPEG_DM365 };

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CVideoCodec  
{
private:
	int			m_nCodecIndex;
	DWORD		m_dwWidth;
	DWORD		m_dwHeight;
	HANDLE		m_hDec;
	
	
	//..................................................

public:
	CVideoCodec();
	CVideoCodec( int nCodecIndex );
	virtual ~CVideoCodec();

	//..................................................

	DWORD GetWidth();
	DWORD GetHeight();
	
	//..................................................

	BOOL DEC_VIDEO( PBYTE pbENCBuf, PBYTE pDECYUV, DWORD dwVideoSize, int *lpnWidth, int *lpnHeight, DWORD *lpdwNumberOfChannels );
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_VIDEOCODEC_H__BF120ABD_BBFA_4D13_8C3F_F3A371756E6B__INCLUDED_)
