// VideoDraw.h: interface for the CVideoDraw class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIDEODRAW_H__9CC8855B_B112_43FF_B305_9F0EA9B99A5D__INCLUDED_)
#define AFX_VIDEODRAW_H__9CC8855B_B112_43FF_B305_9F0EA9B99A5D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <ddraw.h>


#define OVERLAYMASK		RGB(16,0,16)

class CVideoDraw  
{
private:
	CBrush m_pMyBrush[3];
	BOOL    m_isShowMotionArea;
	BYTE    m_MotionSetupArea[32*18];
	HANDLE  m_hLockMotionArea;

	CWnd  * m_pWnd;

	int     m_nWidth;
	int     m_nHeight;


	DDCAPS					m_ddcaps;
	LPDIRECTDRAWCLIPPER	    m_lpClipper;

	LPDIRECTDRAW7           m_lpDD;				// The DirectDraw object
	LPDIRECTDRAWSURFACE7	m_surfacePrimary;	// DirectDraw primary surface
	LPDIRECTDRAWSURFACE7    m_surfaceRGB;		// RGB  back buffer surface

	BOOL InitRGBSurface();
	void MakeRGBDesc(DDSURFACEDESC2 & desc);
	void SurfaceColorFill(LPDIRECTDRAWSURFACE7  pSurf,RECT * pDst,COLORREF rgb);
public:
	CVideoDraw();
	virtual ~CVideoDraw();

	void Init(HWND hWnd, DWORD dwWWidth, DWORD dwWHeight);
	BOOL Start();
	void Stop();
	void Clear();
	void Render();
	void MoveWindow(DWORD dwWWidth, DWORD dwWHeight);
	
	void DrawImage(BYTE *lpData, DWORD dwWidth, DWORD dwHeight, BYTE *lpMotionInfo=NULL, DWORD dwMotionInfoSize=0);
	void Refresh();
	void DrawMotionArea(BYTE *lpMotonInfo,  DWORD dwSize);

	void ShowMotionArea(BOOL bShow);
	void SetMotionInfo(BYTE *lpData,  DWORD dwSize);
	BOOL GetMotionInfo(BYTE *lpData,  DWORD &dwSize);
};

#endif // !defined(AFX_VIDEODRAW_H__9CC8855B_B112_43FF_B305_9F0EA9B99A5D__INCLUDED_)
