// VideoView.cpp : implementation file
//

#include "stdafx.h"
#include "probedemo.h"
#include "VideoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVideoView

CVideoView::CVideoView()
{
	m_isMouseDown = FALSE;
	m_dwImageWidth = 0;
	m_dwImageHeight = 0;
	m_pVideo = new CVideoDraw();
}

CVideoView::~CVideoView()
{
	if(m_pVideo)
	{
		delete m_pVideo;
	}
}


BEGIN_MESSAGE_MAP(CVideoView, CWnd)
	//{{AFX_MSG_MAP(CVideoView)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CVideoView message handlers

void CVideoView::Init(HWND hWnd, DWORD dwWWidth, DWORD dwWHeight)
{

	CWnd * pWnd=CWnd::FromHandle(hWnd);
	if(pWnd)
	{
		m_dwWWidth = dwWWidth;
		m_dwWHeight = dwWHeight;
		CRect rec = CRect(0,0,dwWWidth, dwWHeight);
		if(Create(NULL,NULL,WS_CHILD|WS_VISIBLE,rec, pWnd,2100))
		{

		}
	}
}
void CVideoView::DrawImage(BYTE *lpData, DWORD dwWidth, DWORD dwHeight, BYTE *lpMotionInfo, DWORD dwMotionInfoSize)
{
	m_dwImageWidth = dwWidth;
	m_dwImageHeight = dwHeight;
	m_pVideo->DrawImage(lpData, dwWidth, dwHeight, lpMotionInfo, dwMotionInfoSize);
}
void CVideoView::DrawMotionArea(BYTE *lpMotonInfo,  DWORD dwSize)
{
	m_pVideo->DrawMotionArea(lpMotonInfo, dwSize);
}

void CVideoView::ShowMotionArea(BOOL bShow)
{
	m_pVideo->ShowMotionArea(bShow);
}
void CVideoView::SetMotionInfo(BYTE *lpData,  DWORD dwSize)
{
	m_pVideo->SetMotionInfo(lpData,  dwSize);
}
BOOL CVideoView::GetMotionInfo(BYTE *lpData,  DWORD &dwSize)
{
	return m_pVideo->GetMotionInfo(lpData,  dwSize);	
}

int CVideoView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	if(m_pVideo)
	{
		m_pVideo->Init(GetSafeHwnd(), m_dwWWidth, m_dwWHeight);
	}
	return 0;
}

void CVideoView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	int posX = point.x;
	int posY = point.y;
	
	SetCapture();
	

	RECT rect;
	GetClientRect(&rect);
	float fWidth  = (float)m_dwImageWidth/(float)(rect.right);
	float fHeight = (float)m_dwImageHeight/(float)(rect.bottom);
	
	//if(GetMotionRegion(m_nChannel, &motioninfo))
	{
		int shiftX = (int)((float)posX*fWidth);
		int shiftY = (int)((float)posY*fHeight);
		
		if((m_dwImageWidth==176 && m_dwImageHeight==128) ||
			(m_dwImageWidth==176 && m_dwImageHeight==120) ||
			(m_dwImageWidth==176 && m_dwImageHeight==144) )
		{
			m_rectMT_Temp.left	= m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/3);
			m_rectMT_Temp.top	= m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/3); 
		}	
		else if((m_dwImageWidth==352 && m_dwImageHeight==240) ||
			(m_dwImageWidth==352 && m_dwImageHeight==288))
		{
			m_rectMT_Temp.left	= m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/4);
			m_rectMT_Temp.top	= m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/3);
		}	
		else if((m_dwImageWidth==720 && m_dwImageHeight==576) ||
			(m_dwImageWidth==720 && m_dwImageHeight==480) ||
			(m_dwImageWidth==704 && m_dwImageHeight==576) ||
			(m_dwImageWidth==704 && m_dwImageHeight==480))
		{
			m_rectMT_Temp.left	= m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/9);
			m_rectMT_Temp.top	= m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/6);
		}				
		else if(m_dwImageWidth==1280 && m_dwImageHeight==720)	// HD
		{
			m_rectMT_Temp.left	= m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/16);
			m_rectMT_Temp.top	= m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/9);
		}
		else if(m_dwImageWidth==1920 && (m_dwImageHeight==1080 || m_dwImageHeight==1072))	// full HD
		{
			m_rectMT_Temp.left	= m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/20);
			m_rectMT_Temp.top	= m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/16);
		}
		
		BYTE MotionArea[32*18];
		DWORD dwMotionSize;
		if(m_pVideo->GetMotionInfo(MotionArea,  dwMotionSize))
		{
			MotionArea[32*m_rectMT_Temp.top + m_rectMT_Temp.left] = 0x01;
			m_pVideo->SetMotionInfo(MotionArea,  dwMotionSize);
		}
		
	}


	m_isMouseDown = TRUE;
	CWnd::OnLButtonDown(nFlags, point);
}

void CVideoView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	int posX = point.x;
	int posY = point.y;
	
	m_isMouseDown = FALSE;
	ReleaseCapture(); 	


	CWnd::OnLButtonUp(nFlags, point);
}

void CVideoView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	int posX = point.x;
	int posY = point.y;

	if(m_isMouseDown)
	{
		RECT rect;
		GetClientRect(&rect);
		float fWidth  = (float)m_dwImageWidth/(float)(rect.right);
		float fHeight = (float)m_dwImageHeight/(float)(rect.bottom);

		if( (posX >= rect.left) && (posX <= rect.right) && 
			(posY >= rect.top) && (posY <= rect.bottom))
		{
			int shiftX = (int)((float)posX*fWidth);
			int shiftY = (int)((float)posY*fHeight);

			if((m_dwImageWidth==176 && m_dwImageHeight==128) ||
				(m_dwImageWidth==176 && m_dwImageHeight==120) ||
				(m_dwImageWidth==176 && m_dwImageHeight==144) )
			{			
				m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/3);
				m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/3); 
			}	
			else if((m_dwImageWidth==352 && m_dwImageHeight==240) ||
				(m_dwImageWidth==352 && m_dwImageHeight==288))
			{
				m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/4);
				m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/3);
			}	
			else if((m_dwImageWidth==720 && m_dwImageHeight==576) ||
				(m_dwImageWidth==720 && m_dwImageHeight==480) ||
				(m_dwImageWidth==704 && m_dwImageHeight==576) ||
				(m_dwImageWidth==704 && m_dwImageHeight==480))
			{
				m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/9);
				m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/6);
			}				
			else if(m_dwImageWidth==1280 && m_dwImageHeight==720)	// HD
			{
				m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/16);
				m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/9);
			}
			else if(m_dwImageWidth==1920 && (m_dwImageHeight==1080 || m_dwImageHeight==1072))	// full HD
			{
				m_rectMT_Temp.right	= shiftX/(m_dwImageWidth/20);
				m_rectMT_Temp.bottom	= shiftY/(m_dwImageHeight/16);
			}
			
			CRect rectTemp = m_rectMT_Temp;
			if(rectTemp.left > rectTemp.right )
			{
				int nTemp = rectTemp.left;
				rectTemp.left =  rectTemp.right;
				rectTemp.right = nTemp;
			}
			if(rectTemp.top	 > rectTemp.bottom)
			{
				int nTemp = rectTemp.top;
				rectTemp.top = rectTemp.bottom;
				rectTemp.bottom = nTemp;
			}
			for(int col=rectTemp.top; col<=rectTemp.bottom; col++){
				for(int row=rectTemp.left; row<=rectTemp.right; row++){

					BYTE MotionArea[32*18];
					DWORD dwMotionSize;
					if(m_pVideo->GetMotionInfo(MotionArea,  dwMotionSize))
					{
						MotionArea[32*col + row] = 0x01;
						m_pVideo->SetMotionInfo(MotionArea,  dwMotionSize);
					}
				}
			}
		}
	}
	
	CWnd::OnMouseMove(nFlags, point);
}
