// WaveInUtil.cpp: implementation of the CWaveInUtil class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "WaveInUtil.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CWaveInUtil::CWaveInUtil(int nChannel, int nSamplesPerSec, int nBitsPerSample)
{
	m_pMyDS = NULL;
	m_nChannel	= nChannel;
	m_nSamplesPerSec = nSamplesPerSec;
	m_nBitsPerSample = nBitsPerSample;
}

CWaveInUtil::~CWaveInUtil()
{
	Stop();

	if (NULL != m_pMyDS) {
		delete m_pMyDS;
		m_pMyDS = NULL;
	}
}

void CWaveInUtil::InitSoundCapture(LPFNC_CAPTUREDATA Function_Callback, LPVOID lpCallbackData)
{
	//Initilize CMyDirectSound
	if (NULL == m_pMyDS) {
		m_pMyDS = new CSoundCaptureManager;
	}

	DWORD dwPrimaryChannels = m_nChannel;
	DWORD dwPrimaryFreq     = m_nSamplesPerSec;
	DWORD dwPrimaryBitRate  = m_nBitsPerSample; // 16bit

	m_pMyDS->Initialize(Function_Callback, lpCallbackData, dwPrimaryChannels, dwPrimaryFreq, dwPrimaryBitRate);
}

void CWaveInUtil::Start()
{
	if(m_pMyDS)
	{
		m_pMyDS->StartCapture();
	}
}

void CWaveInUtil::Stop()
{
	if (NULL != m_pMyDS) {
		
		m_pMyDS->StopCapture();	
	}
}


