// ProbeNetCtrlrDll.h: interface for the CProbeNetCtrlrDll class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROBENETCTRLRDLL_H__4A5845E2_D7E7_467A_8893_765F90A908A4__INCLUDED_)
#define AFX_PROBENETCTRLRDLL_H__4A5845E2_D7E7_467A_8893_765F90A908A4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ProbeNetCtrlrDef.h"


#ifdef _PROBENET_DLL_

const DEFAULT_OVERLAPPED_COUNT = 5;      // default number of overlapped recvs to post
const MAX_CONNECTIONS          = 5;      // max number of connections 
const MAX_IO_THREAD_COUNT      = 100;      // max creatable io thread obj
const STREAM_BUFFER_COUNT      = 2;

///// socket operation
const OP_ACCEPT       = 0;               // AcceptEx
const OP_READ         = 1;               // WSARecv/WSARecvFrom
const OP_WRITE        = 2;               // WSASend?WSASendTo

const CONNECTION_UNACTIVE = 0;
const CONNECTION_ACTIVE   = 1;

	#define API_PROBENET extern "C" __declspec(dllexport)
#else
	#define API_PROBENET extern "C" __declspec(dllimport)
	#ifdef _DEBUG
		#pragma comment(lib, "../libd/ProbeNetCtrlr.lib")
		#pragma message("Automatically linking with ../libd/ProbeNetCtrlr.lib")
	#else
		#pragma comment(lib, "../lib/ProbeNetCtrlr.lib")
		#pragma message("Automatically linking with ../lib/ProbeNetCtrlr.lib")
	#endif
#endif


	API_PROBENET   void _PROBENET_INIT();
	API_PROBENET   void _PROBENET_END();


	API_PROBENET   HANDLE _PROBENET_CONNECTION_INIT(CONNECTION_INFO *lpConnectionInfo, DWORD dwMaskCreatingSocks, DWORD dwProductType=11);
	API_PROBENET   void _PROBENET_CONNECTION_END(HANDLE handle);
	API_PROBENET   void _PROBENET_CONNECTION_SETVALUE(HANDLE handle, CONNECTION_INFO *lpConnectionInfo);


	API_PROBENET   BOOL _PROBENET_CONNECTION_GETSTATUS(HANDLE handle, DWORD *lpStatus);
	API_PROBENET   void _PROBENET_CONNECTION_SETCTRLCALLFUNC(HANDLE handle, 
													LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvCtrlMsg, 
													LPSOCKETFUNC_ON_ERROR OnError, 
													HANDLE hCallback);
	API_PROBENET   void _PROBENET_CONNECTION_SETSTREAMCALLFUNC(HANDLE handle, 
													LPSOCKETFUNC_ON_RECV_VIDEO_DATA OnRecvVideo,
													LPSOCKETFUNC_ON_RECV_AUDIO_DATA OnRecvAudio,
													LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvVideoMsg, 
													LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvAudioMsg,
													LPSOCKETFUNC_ON_ERROR OnErrorVideo,
													LPSOCKETFUNC_ON_ERROR OnErrorAudio, 
													HANDLE hCallback);
	API_PROBENET   void _PROBENET_CONNECTION_SETAUDIOSENDERCALLFUNC(HANDLE handle, 
															LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvCtrlMsg, 
															LPSOCKETFUNC_ON_ERROR OnError, 
															HANDLE hCallback);
	API_PROBENET   void _PROBENET_CONNECTION_CONNECT(HANDLE handle, DWORD dwMaskCreatingSocks);
	API_PROBENET   void _PROBENET_CONNECTION_DISCONNECT(HANDLE handle, DWORD dwMaskCreatingSocks);
	API_PROBENET   void _PROBENET_CONNECTION_DISCONNECTALL(HANDLE handle);
	API_PROBENET   int  _PROBENET_CONNECTION_SENDCOMMAND(HANDLE handle, char *szCmd, BYTE *lpParam, DWORD dwParamSize);
	API_PROBENET   void _PROBENET_CONNECTION_SETCHANNEL(HANDLE handle, int nChannel);
	API_PROBENET   int  _PROBENET_CONNECTION_SENDAUDIOPACK(HANDLE handle, AUDIO_DATA_PACK *lpData);

	API_PROBENET   BOOL  _PROBENET_CONNECTION_GETENCODESETUPINFO(HANDLE handle, int nChannel, ENCODE_SETUP_INFO *lpData, BOOL bRefreshData=TRUE);
	API_PROBENET   int   _PROBENET_CONNECTION_SETENCODESETUPINFO(HANDLE handle, ENCODE_SETUP_INFO *lpData);

	API_PROBENET   void _PROBENET_CTRL_SETCALLFUNC(HANDLE handle, 
													LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvCtrlMsg, 
													LPSOCKETFUNC_ON_ERROR OnError, 
													HANDLE hCallback);
	API_PROBENET   void _PROBENET_CTRL_CONNECT(HANDLE handle);
	API_PROBENET   int  _PROBENET_CTRL_SENDCOMMAND(HANDLE handle, char *szCmd, BYTE *lpParam, DWORD dwParamSize);
	API_PROBENET   void _PROBENET_CTRL_DISCONNECT(HANDLE handle);

	API_PROBENET   void _PROBENET_STREAM_SETCALLFUNC(HANDLE handle, 
													LPSOCKETFUNC_ON_RECV_VIDEO_DATA OnRecvVideo,
													LPSOCKETFUNC_ON_RECV_AUDIO_DATA OnRecvAudio,
													LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvVideoMsg, 
													LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvAudioMsg, 
													LPSOCKETFUNC_ON_ERROR OnErrorVideo, 
													LPSOCKETFUNC_ON_ERROR OnErrorAudio,
													HANDLE hCallback);
	API_PROBENET   void _PROBENET_STREAM_CONNECT(HANDLE handle);
	API_PROBENET   void _PROBENET_STREAM_DISCONNECT(HANDLE handle);
	API_PROBENET   void _PROBENET_STREAM_SETCHANNEL(HANDLE handle, int nChannel);

	API_PROBENET   void _PROBENET_AUDIOSENDER_SETCALLFUNC(HANDLE handle, 
															LPSOCKETFUNC_ON_RECV_CTRL_DATA OnRecvCtrlMsg, 
															LPSOCKETFUNC_ON_ERROR OnError, 
															HANDLE hCallback);
	API_PROBENET   void _PROBENET_AUDIOSENDER_CONNECT(HANDLE handle);
	API_PROBENET   void _PROBENET_AUDIOSENDER_DISCONNECT(HANDLE handle);
	API_PROBENET   int  _PROBENET_AUDIOSENDER_SENDPACK(HANDLE handle, AUDIO_DATA_PACK *lpData);


	


#endif // !defined(AFX_PROBENETCTRLRDLL_H__4A5845E2_D7E7_467A_8893_765F90A908A4__INCLUDED_)
